;;; Sierra Script 1.0 - (do not remove this comment)
(script# INVENTORY_SCRIPT)
(include sci.sh)
(include game.sh)
(include 15.shm)
(use Main)
(use ScrollableInventory)
(use ScrollInsetWindow)
(use Print)
(use IconItem)
(use InventoryItem)
(use System)
(public
	invCode 0
	invWin 1
)

(instance sq5Inv of ScrollableInventory
	(properties)
	
	(method (init)
		(super init: &rest)
		(invWin
			color: gColorWindowForeground
			back: 3
			topBordColor: 5
			lftBordColor: 4
			rgtBordColor: 2
			botBordColor: 1
			insideColor: 2
			topBordColor2: 1
			lftBordColor2: 1
			botBordColor2: 6
			rgtBordColor2: 6
		)
		(self
			add: FloppyDisk EmptyMug FullMug SaltyFullMug Salt AudioTour
			eachElementDo: #lowlightColor 2
			add: invLook invSelect invHelp invUp invDown ok
		)
		(self
			state: 2048
			upIcon: invUp
			downIcon: invDown
			window: invWin
			helpIconItem: invHelp
			selectIcon: invSelect
			okButton: ok
			numCols: 5
			scrollAmount: 5
			dispAmount: 10
			empty: 13
			normalHeading: 15
			eachElementDo: #highlightColor 0
			eachElementDo: #modNum INVENTORY_SCRIPT
			eachElementDo: #init
		)
	)
)

(instance invCode of Code
	(properties)
	
	(method (init)
		(= gInv sq5Inv)
		(gInv init:)
	)
)

(instance invWin of ScrollInsetWindow
	(properties
		priority -1
		topBordHgt 30
		botBordHgt 5
	)
	
	(method (open)
		(invLook
			nsLeft: (- (/ (- (self right?) (self left?)) 2) 84)
		)
		(invLook nsTop: 2)
		(super open: &rest)
	)
)

(instance invUp of IconItem
	(properties
		view 991
		loop 5
		cel 0
		cursor 999
		maskView 991
		maskLoop 5
		maskCel 2
		lowlightColor 5
		noun N_UPICON
		helpVerb V_HELP
	)
	
	(method (select)
		(if (super select: &rest) (gInv scroll: -1))
		(return 0)
	)
)

(instance invDown of IconItem
	(properties
		view 991
		loop 6
		cel 0
		cursor 999
		maskView 991
		maskLoop 6
		maskCel 2
		lowlightColor 5
		noun N_DOWNICON
		helpVerb V_HELP
	)
	
	(method (select)
		(if (super select: &rest) (gInv scroll: 1))
		(return 0)
	)
)

(instance ok of IconItem
	(properties
		view 991
		loop 3
		cel 0
		cursor 999
		signal $0043
		lowlightColor 5
		noun N_CLOSEBUTTON
		helpVerb V_HELP
	)
)

(instance invLook of IconItem
	(properties
		view 991
		loop 2
		cel 0
		cursor 981
		message 1
		signal $0081
		lowlightColor 5
		noun N_DESCICON
		helpVerb V_HELP
	)
)

(instance invHand of IconItem
	(properties
		view 991
		loop 0
		cel 0
		cursor 982
		message 4
		lowlightColor 5
		noun N_DOICON
		helpVerb V_HELP
	)
)

(instance invHelp of IconItem
	(properties
		view 991
		loop 1
		cel 0
		cursor 989
		message 5
		lowlightColor 5
		noun N_HELPICON
		helpVerb V_HELP
	)
)

(instance invSelect of IconItem
	(properties
		view 991
		loop 4
		cel 0
		cursor 999
		lowlightColor 5
		noun N_SELECTICON
		helpVerb V_HELP
	)
)

(instance FloppyDisk of InventoryItem
	(properties
		view 900
		loop 1
		cursor 900
		message V_FLOPPYDISK
		signal $0002
		noun N_FLOPPYDISK
	)
)

(instance EmptyMug of InventoryItem
	(properties
		view 901
		loop 1
		cursor 901
		message V_FILLMUG
		signal $0002
		noun N_EMPTYMUG
	)
)

(instance FullMug of InventoryItem
	(properties
		view 903
		loop 1
		cursor 903
		message V_DUMPMUG
		signal $0002
		noun N_FULLMUG
	)
	
	(method (doVerb theVerb)
		(switch theVerb
			(V_SALT
				(gInv hide:)
				(gEgo put: INV_SALT)
				(gEgo put: INV_FULLMUG)
				(gEgo get: INV_SALTYFULLMUG)
				(super doVerb: theVerb &rest)
				(ScoreFlag F_PutSaltInMug 5)
			)
			(else  (super doVerb: theVerb &rest))
		)
	)
)

(instance SaltyFullMug of InventoryItem
	(properties
		view 904
		loop 1
		cursor 904
		message V_DUMPSALTYMUG
		signal $0002
		noun N_SALTYFULLMUG
	)
)

(instance Salt of InventoryItem
	(properties
		view 902
		loop 1
		cursor 902
		message V_SALT
		signal $0002
		noun N_SALT
	)
)

(instance AudioTour of InventoryItem
	(properties
		view 905
		loop 1
		cursor 905
		message V_AUDIOTOUR
		signal $0002
		noun N_AUDIOTOUR
	)
)