;;; Sierra Script 1.0 - (do not remove this comment)
(script# 0)
(include sci.sh)
(include game.sh)
(include 0.shm)
(use ColorInit)
(use Smopper)
(use GameEgo)
(use ScrollableInventory)
(use ScrollInsetWindow)
(use DColorButton)
(use SpeakWindow)
(use Print)
(use DIcon)
(use Messager)
(use Talker)
(use PseudoMouse)
(use Scaler)
(use BorderWindow)
(use IconItem)
(use RandCycle)
(use PolyPath)
(use Polygon)
(use StopWalk)
(use Timer)
(use Grooper)
(use Sound)
(use Game)
(use User)
(use System)
(use File)
(public
	SQ5 0
	Btest 1
	Bset 2
	Bclear 3
	RestorePreviousHandsOn 4
	IsObjectOnControl 5
	SetUpEgo 6
	AddToScore 7
	proc0_8 8
	Die 9
	ScoreFlag 10
	HideStatus 11
	DebugPrint 12
	AddPolygonsToRoom 13
	CreateNewPolygon 14
)
(define STARTING_ROOM 100)
(local
	gEgo
	gGame
	gRoom
	global3 ; Unused
	gQuitGame =  FALSE
	gCast
	gRegions
	gTimers
	gSounds
	gInv
	gAddToPics
	gRoomNumber ; Brian called this gRoomNumberExit. It's what gets set to move to the next room, which will then be gNewRoomNumber
	; It's used everywhere in place of gNewRoomNumber here though.
	gPreviousRoomNumber
	gNewRoomNumber
	gDebugOnNextRoom
	gScore
	gMaxScore
	gTextCode
	gCuees
	gCursorNumber
	gNormalCursor =  999
	gWaitCursor =  997
	gFont =  1
	gSmallFont =  4
	gPEvent
	gDialog
	gBigFont =  1
	gVersion
	gSaveDir
	gPicAngle
	gFeatures
	gUseSortedFeatures
	gPicNumber =  -1
	gDoMotionCue
	gWindow
	global39 ; Unused	(foreground text?)
	global40 ; Unused	(window background color?)
	gOldPort
	[global42 21] ; debug filename
	gGameControls
	gFeatureInit
	gDoVerbCode
	gApproachCode
	gEgoUseObstacles =  1          ; Has something to do with default Motion for ego (0: MoveTo, 1: PolyPath, 2: PolyPath...)
	gIconBar
	gPEventX
	gPEventY
	gOldKH
	gOldMH
	gOldDH
	gPseudoMouse
	gTheDoits
	gEatTheMice =  60
	gUser
	gSyncBias    ; Something to do with Sync
	gTheSync
	global83 ; Something to do with audio narration
	gFastCast
	gInputFont
	gTickOffset  ; Something to do with time (ticks per frame?)
	gGameTime
	gNarrator
	gMessageType =  $0001        ; Seems to be a flag for talker: 0x1 (text) and 0x2 (audio)
	gMessager
	gPrints
	gWalkHandler
	gTextReadSpeed =  2
	gAltPolyList
	gColorDepth
	gPolyphony
	gStopGroop
	global107
	gCurrentIcon
	gGUserCanControl
	gGUserCanInput
	gCheckedIcons
	gState
	gNewSpeakWindow
	gSq5Win_2
	gDeathReason
	gMusic1
	gDongle =  1234         ; This variable CAN'T MOVE
	gMusic2
	gCurrentTalkerNumber
	gGEgoMoveSpeed
	gColorWindowForeground
	gColorWindowBackground
	gLowlightColor
	gDefaultEgoView =  0
	gRegister
	[gFlags 14] ; Start of bit set. Room for 14x16 = 224 flags.
	gEdgeDistance =  10          ; Margin around screen to make it easier to walk the ego to the edge
	gDebugOut
	[gPuzzlePieceSlot 9] = [-1 -1 -1 -1 -1 -1 -1 -1 -1]
)                               ; Index (standard reading order) of each piece.
(procedure (Btest param1)
	(return (& [gFlags (/ param1 16)] (>> $8000 (mod param1 16))))
)

(procedure (Bset param1 &tmp temp0)
	(= temp0 (Btest param1))
	(= [gFlags  (/ param1 16)]
		(| [gFlags (/ param1 16)] (>> $8000 (mod param1 16)))
	)
	(return temp0)
)

(procedure (Bclear param1 &tmp temp0)
	(= temp0 (Btest param1))
	(= [gFlags  (/ param1 16)]
		(&
			[gFlags
			(/ param1 16)]
			(~ (>> $8000 (mod param1 16)))
		)
	)
	(return temp0)
)

(procedure (RestorePreviousHandsOn &tmp temp0)
	(gUser
		canControl: gGUserCanControl
		canInput: gGUserCanInput
	)
	(= temp0 0)
	(while (< temp0 8)
		(if (& gCheckedIcons (>> $8000 temp0))
			(gIconBar disable: temp0)
		)
		(++ temp0)
	)
)

(procedure (IsObjectOnControl param1 param2)
	(return (if (& (param1 onControl: 1) param2) (return 1) else 0))
)

(procedure (SetUpEgo param1 param2)
	(if (and (> argc 0) (!= param1 -1))
		(gEgo view: param1)
		(if (and (> argc 1) (!= param2 -1))
			(gEgo loop: param2)
		)
	else
		(gEgo view: gDefaultEgoView)
		(if (and (> argc 1) (!= param2 -1))
			(gEgo loop: param2)
		)
	)
	(if (gEgo looper?) ((gEgo looper?) dispose:))
	(gEgo
		setStep: 5 2
		illegalBits: 0
		ignoreActors: 0
		setSpeed: gGEgoMoveSpeed
		; signal(| (send gEgo:signal) $1000)
		heading:
			(switch (gEgo loop?)
				(0 90)
				(1 270)
				(2 180)
				(3 0)
				(4 135)
				(5 225)
				(6 45)
				(7 315)
			)
	)
	(gEgo
		setLoop: -1
		setLoop: stopGroop
		setPri: -1
		setMotion: NULL
		state: (| (gEgo state?) $0002)
	)
)

(procedure (proc0_8 param1 param2 param3 param4 &tmp temp0 temp1 temp2 temp3 temp4)
	(= temp3 0)
	(= temp4 0)
	(if (IsObject param2)
		(= temp1 (param2 x?))
		(= temp2 (param2 y?))
		(if (> argc 2)
			(if (IsObject param3)
				(= temp3 param3)
			else
				(= temp4 param3)
			)
			(if (== argc 4) (= temp3 param4))
		)
	else
		(= temp1 param2)
		(= temp2 param3)
		(if (== argc 4) (= temp3 param4))
	)
	(if temp4 (proc0_8 param2 param1))
	(= temp0
		(GetAngle (param1 x?) (param1 y?) temp1 temp2)
	)
	(param1
		setHeading: temp0 (if (IsObject temp3) temp3 else 0)
	)
)

(procedure (Die param1)
	(if (not argc)
		(= gDeathReason 1)
	else
		(= gDeathReason param1)
	)
	(gRoom newRoom: DEATH_SCRIPT)
)

(procedure (AddToScore amount)
	(= gScore (+ gScore amount))
	(statusLineCode doit:)
	(rm0Sound
		priority: 15
		number: 1000
		loop: 1
		flags: 1
		play:
	)
)

(procedure (ScoreFlag flag amount)
	(if (not (Btest flag))
		(AddToScore amount)
		(Bset flag)
	)
)

(procedure (HideStatus &tmp temp0)
	(= temp0 (GetPort))
	(SetPort -1)
	(Graph grFILL_BOX 0 0 10 320 VISUAL 0 -1 -1)
	(Graph grUPDATE_BOX 0 0 10 320 VISUAL)
	(SetPort temp0)
)

(procedure (DebugPrint)
	(if gDebugOut (gDebugOut debugPrint: &rest))
)

; Returns the position of the next polygon in the buffer
(procedure (CreateNewPolygonHelper polyBuffer newPolyAddress &tmp newPoly pointCount)
	(= newPoly (Polygon new:))
	(= pointCount (Memory memPEEK (+ polyBuffer 2)))
	(newPoly
		dynamic: FALSE
		type: (Memory memPEEK polyBuffer)
		size: pointCount
		; Use the points directly from the buffer:
		points: (+ polyBuffer 4)
	)
	(Memory memPOKE newPolyAddress newPoly)
	(return (+ polyBuffer (+ 4 (* 4 pointCount))))
)

(procedure (AddPolygonsToRoom polyBuffer &tmp polyCount newPolygon)
	(if (u< polyBuffer 100)
		(Prints
			{polyBuffer is not a pointer. Polygon ignored.}
		)
	else
		(= polyCount (Memory memPEEK polyBuffer))
		(+= polyBuffer 2)
		(while polyCount
			(= polyBuffer
				(CreateNewPolygonHelper polyBuffer @newPolygon)
			)
			(gRoom addObstacle: newPolygon)
			(-- polyCount)
		)
	)
)

(procedure (CreateNewPolygon polyBuffer &tmp polyCount newPolygon)
	(if (u< polyBuffer 100)
		(Prints
			{polyBuffer is not a pointer. Polygon ignored.}
		)
		(return NULL)
	else
		(= polyCount (Memory memPEEK polyBuffer))
		(+= polyBuffer 2)
		(CreateNewPolygonHelper polyBuffer @newPolygon)
		(return newPolygon)
	)
)

(instance rm0Sound of Sound
	(properties
		priority 15
	)
)

(instance sq5Music1 of Sound
	(properties
		flags $0001
	)
)

(instance sq5Music2 of Sound
	(properties
		flags $0001
	)
)

(instance stopGroop of GradualLooper
	(properties)
)

(instance egoStopWalk of FiddleStopWalk
	(properties)
)

(instance ego of GameEgo
	(properties)
)

(instance statusLineCode of Code
	(properties)
	
	(method (doit &tmp [temp0 50] [temp50 50] temp100)
		(= temp100 (GetPort))
		(SetPort -1)
		(Graph grFILL_BOX 0 0 10 320 VISUAL 5 -1 -1)
		(Graph grUPDATE_BOX 0 0 10 320 VISUAL)
		(Message msgGET 0 N_TITLEBAR 0 0 1 @temp0)
		(Format @temp50 {%s %d} @temp0 gScore)
		(Display @temp50 dsCOORD 4 0 dsFONT gFont dsCOLOR 6)
		(Display @temp50 dsCOORD 6 2 dsFONT gFont dsCOLOR 4)
		(Display @temp50 dsCOORD 5 1 dsFONT gFont dsCOLOR 0)
		(Graph grDRAW_LINE 0 0 0 319 7 -1 -1)
		(Graph grDRAW_LINE 0 0 9 0 6 -1 -1)
		(Graph grDRAW_LINE 9 0 9 319 4 -1 -1)
		(Graph grDRAW_LINE 0 319 9 319 3 -1 -1)
		(Graph grUPDATE_BOX 0 0 10 319 VISUAL)
		(SetPort temp100)
	)
)

(instance sq5IconBar of IconBar
	(properties)
	
	(method (show)
		(if (IsObject curInvIcon) (curInvIcon loop: 2))
		(super show:)
		(if (IsObject curInvIcon) (curInvIcon loop: 1))
	)
	
	(method (hide)
		(super hide: &rest)
		(gGame setCursor: gCursorNumber 1)
	)
	
	(method (noClickHelp &tmp temp0 temp1 temp2 temp3 gSq5WinEraseOnly)
		(= temp2 0)
		(= temp1 temp2)
		(= temp3 (GetPort))
		(= gSq5WinEraseOnly (gWindow eraseOnly?))
		(gWindow eraseOnly: 1)
		(while (not ((= temp0 ((gUser curEvent?) new:)) type?))
			(if (not (self isMemberOf: IconBar)) (temp0 localize:))
			(= temp2 (self firstTrue: #onMe temp0))
			(cond 
				(temp2
					(if
						(and
							(!= (= temp2 (self firstTrue: #onMe temp0)) temp1)
							(temp2 helpVerb?)
						)
						(= temp1 temp2)
						(if gDialog (gDialog dispose:))
						(Print
							font: gFont
							width: 250
							addText:
								(temp2 noun?)
								(temp2 helpVerb?)
								0
								1
								0
								0
								(temp2 modNum?)
							modeless: 1
							init:
						)
						(Animate (gCast elements?) 0)
						(SetPort temp3)
					)
				)
				(gDialog (gDialog dispose:) (Animate (gCast elements?) 0))
				(else (= temp1 0))
			)
			(temp0 dispose:)
		)
		(gWindow eraseOnly: gSq5WinEraseOnly)
		(gGame setCursor: 999 1)
		(if gDialog
			(gDialog dispose:)
			(Animate (gCast elements?) 0)
		)
		(SetPort temp3)
		(if (not (helpIconItem onMe: temp0))
			(self dispatchEvent: temp0)
		)
	)
)

(class SQ5 of Game
	(properties
		script 0
		printLang 1
		_detailLevel 3
		panelObj 0
		panelSelector 0
		handsOffCode 0
		handsOnCode 0
	)
	
	(method (init &tmp [temp0 7] temp7)
		((ScriptID INVENTORY_SCRIPT 0) init:)
		(super init:)
		(= gEgo ego)
		(User alterEgo: gEgo canControl: 0 canInput: 0)
		(= gMessageType $0003)
		; = gMessageType $0003
		; = global83 TRUE
		(= gUseSortedFeatures 1)
		(= gPolyphony (DoSound sndGET_POLYPHONY))
		(= gMaxScore 5000)
		(= gFont 1605)
		(= gGEgoMoveSpeed 6)
		(= gEatTheMice 30)
		(= gTextReadSpeed 2)
		(= gColorDepth (Graph grGET_COLOURS))
		(= gStopGroop stopGroop)
		(= gPseudoMouse PseudoMouse)
		(gEgo setLoop: gStopGroop)
		; The position of these font resource numbers correspond to font codes used in messages:
		(TextFonts 1605 1605 1605 1605 1605 2106)
		; These correspond to color codes used in messages (values into global palette):
		(TextColors 0 15 26 31 34 52 63)
		(= gVersion {x.yyy.zzz})
		(= temp7 (FileIO fiOPEN {version} fOPENFAIL))
		(FileIO fiREAD_STRING gVersion 11 temp7)
		(FileIO fiCLOSE temp7)
		(ColorInit)
		(DisposeScript COLORINIT_SCRIPT)
		(= gNarrator sQ5Narrator)
		(= gWindow sq5Win)
		(= gSq5Win_2 sq5Win)
		(= gMessager testMessager)
		(= gNewSpeakWindow (SpeakWindow new:))
		(gWindow
			color: gColorWindowForeground
			back: gColorWindowBackground
		)
		(gGame
			setCursor: gCursorNumber TRUE 304 172
			detailLevel: 3
		)
		(= gMusic1 sq5Music1)
		(gMusic1 owner: self flags: 1 init:)
		; number(1)
		(= gMusic2 sq5Music2)
		(gMusic2 owner: self flags: 1 init:)
		; number(1)
		(= gIconBar sq5IconBar)
		(gIconBar
			; These correspond to ICONINDEX_*** in game.sh
			add: icon0 icon1 icon2 icon3 icon4 icon6 icon7 icon8 icon9
			eachElementDo: #init
			eachElementDo: #highlightColor 0
			eachElementDo: #lowlightColor 5
			curIcon: icon0
			useIconItem: icon6
			helpIconItem: icon9
			walkIconItem: icon0
			disable: ICONINDEX_CURITEM
			state: 3072
			disable:
		)
		(= gNormalCursor 999)
		(= gWaitCursor 996)
		(= gDoVerbCode lb2DoVerbCode)
		(= gFeatureInit lb2FtrInit)
		(= gApproachCode lb2ApproachCode)
	)
	
	(method (doit)
		(if (GameIsRestarting)
			(if (IsOneOf gRoomNumber TITLEROOM_SCRIPT)
				(HideStatus)
			else
				(statusLineCode doit:)
			)
			(= gColorDepth (Graph grGET_COLOURS))
		)
		(super doit: &rest)
	)
	
	(method (play &tmp deleteMe debugRoom theStartRoom)
		(= gGame self)
		(= gSaveDir (GetSaveDir))
		(if (not (GameIsRestarting)) (GetCWD gSaveDir))
		(self setCursor: gWaitCursor 1 init:)
		(= theStartRoom STARTING_ROOM)
		(if (not (GameIsRestarting))
			(if (FileIO fiEXISTS {sdebug.txt})
				(= gDebugOut (ScriptID DEBUGOUT_SCRIPT 0))
				(DebugPrint {Debugger enabled})
				(= debugRoom (gDebugOut init: {sdebug.txt}))
				(if (!= debugRoom -1)
					(= theStartRoom debugRoom)
					(gGame handsOn:)
					(DebugPrint {Starting in room %d} theStartRoom)
				)
			)
		)
		(self newRoom: theStartRoom)
		(while (not gQuitGame)
			(self doit:)
			(Wait 1)
		)
	)
	 ; Seems to work ok.
	(method (startRoom param1 &tmp [temp0 4])
		(if (IsOneOf param1 TITLEROOM_SCRIPT 1111)
			(HideStatus)
		else
			(statusLineCode doit:)
		)
		(if gPseudoMouse (gPseudoMouse stop:))
		((ScriptID DISPOSECODE_SCRIPT) doit: param1)
		(super startRoom: param1)
	)
	
	(method (restart &tmp temp0 temp1)
		(= temp1 ((gIconBar curIcon?) cursor?))
		(gGame setCursor: 999)
		(= temp0
			(Print
				font: gFont
				width: 75
				window: gWindow
				mode: 1
				addText: N_RESTART V_LOOK 0 1 0 0 0
				addColorButton: 1 N_RESTART V_LOOK 0 2 0 40 0
				addColorButton: 0 N_RESTART V_LOOK 0 3 0 50 0
				init:
			)
		)
		(if temp0
			(super restart: &rest)
		else
			(gGame setCursor: temp1)
		)
	)
	
	(method (restore &tmp [temp0 2])
		(super restore: &rest)
		(gGame setCursor: ((gIconBar curIcon?) cursor?))
	)
	
	(method (save)
		(super save: &rest)
		(gGame setCursor: ((gIconBar curIcon?) cursor?))
	)
	
	(method (handleEvent pEvent &tmp theGCursorNumber)
		(super handleEvent: pEvent)
		(if (pEvent claimed?) (return 1))
		(return
			(switch (pEvent type?)
				(evKEYBOARD
					(switch (pEvent message?)
						(KEY_TAB
							(if (not (& ((gIconBar at: 6) signal?) icDISABLED))
								(if gFastCast (return gFastCast))
								(= theGCursorNumber gCursorNumber)
								(gInv showSelf: gEgo)
								(gGame setCursor: theGCursorNumber 1)
								(pEvent claimed: 1)
							)
						)
						(KEY_CONTROL
							(if (not (& ((gIconBar at: 7) signal?) icDISABLED))
								(gGame quitGame:)
								(pEvent claimed: 1)
							)
						)
						(JOY_RIGHT
							(if (not (& ((gIconBar at: 7) signal?) icDISABLED))
								(= theGCursorNumber ((gIconBar curIcon?) cursor?))
								((ScriptID 24 0) doit:)
								(gGameControls dispose:)
								(gGame setCursor: theGCursorNumber 1)
							)
						)
						(KEY_F2
							(cond 
								((gGame masterVolume:) (gGame masterVolume: 0))
								((> gPolyphony 1) (gGame masterVolume: 15))
								(else (gGame masterVolume: 1))
							)
							(pEvent claimed: 1)
						)
						(KEY_F5
							(if (not (& ((gIconBar at: 7) signal?) icDISABLED))
								(if gFastCast (return gFastCast))
								(= theGCursorNumber gCursorNumber)
								(gGame save:)
								(gGame setCursor: theGCursorNumber 1)
								(pEvent claimed: 1)
							)
						)
						(KEY_F7
							(if (not (& ((gIconBar at: 7) signal?) icDISABLED))
								(if gFastCast (return gFastCast))
								(= theGCursorNumber gCursorNumber)
								(gGame restore:)
								(gGame setCursor: theGCursorNumber 1)
								(pEvent claimed: 1)
							)
						)
						(KEY_EXECUTE
							(if (gUser controls?)
								(= gGEgoMoveSpeed (gEgo moveSpeed?))
								(= gGEgoMoveSpeed (Max 0 (-- gGEgoMoveSpeed)))
								(gEgo setSpeed: gGEgoMoveSpeed)
							)
						)
						(KEY_SUBTRACT
							(if (gUser controls?)
								(= gGEgoMoveSpeed (gEgo moveSpeed?))
								(gEgo setSpeed: (++ gGEgoMoveSpeed))
							)
						)
						(61 (if (gUser controls?) (gEgo setSpeed: 6)))
						(KEY_ALT_v
							(Print
								addText: {Version number:} 0 0
								addText: gVersion 0 14
								init:
							)
						)
						(KEY_ALT_d ((ScriptID 10 0) init:))
						; Script-base debugger
						(else  (pEvent claimed: 0))
					)
				)
			)
		)
	)
	
	(method (setCursor cursorNumber param2 param3 param4 &tmp theGCursorNumber)
		(= theGCursorNumber gCursorNumber)
		(if argc
			(if (IsObject cursorNumber)
				(= gCursorNumber cursorNumber)
				(gCursorNumber init:)
			else
				(= gCursorNumber cursorNumber)
				(SetCursor gCursorNumber 0 0)
			)
		)
		(if (and (> argc 1) (not param2)) (SetCursor 996 0 0))
		(if (> argc 2) (SetCursor param3 param4))
		(return theGCursorNumber)
	)
	
	(method (quitGame &tmp temp0 temp1)
		(= temp1 ((gIconBar curIcon?) cursor?))
		(gGame setCursor: 999)
		(= temp0
			(Print
				font: gFont
				width: 75
				mode: 1
				addText: N_QUITMENU V_LOOK 0 1 0 0 0
				addColorButton: 1 N_QUITMENU V_LOOK 0 2 0 25 0
				addColorButton: 0 N_QUITMENU V_LOOK 0 3 0 35 0
				init:
			)
		)
		(if temp0
			(Print addText: 19 1 0 4 0 0 0 init:)
			(super quitGame: &rest)
		else
			(gGame setCursor: temp1)
		)
	)
	
	(method (pragmaFail)
		(if (User canControl:)
			(switch ((gUser curEvent?) message?)
				(V_DO (gMessager say: 0 V_DO 0 (Random 1 2) 0 0))
				(V_TALK
					(gMessager say: 0 V_TALK 0 (Random 1 2) 0 0)
				)
				(else 
					(if (not (IsOneOf ((gUser curEvent?) message?) V_LOOK))
						(gMessager say: 0 V_COMBINE 0 (Random 2 3) 0 0)
					)
				)
			)
		)
	)
	
	(method (handsOff)
		(if (not gCurrentIcon)
			(= gCurrentIcon (gIconBar curIcon?))
		)
		(= gGUserCanControl (gUser canControl:))
		(= gGUserCanInput (gUser canInput:))
		(gUser canControl: 0 canInput: 0)
		(gEgo setMotion: 0)
		(= gCheckedIcons 0)
		(gIconBar eachElementDo: #perform checkIcon)
		(gIconBar curIcon: (gIconBar at: 7))
		(gIconBar disable:)
		(gIconBar
			disable:
				ICONINDEX_WALK
				ICONINDEX_LOOK
				ICONINDEX_DO
				ICONINDEX_TALK
				ICONINDEX_CUSTOM
				ICONINDEX_CURITEM
				ICONINDEX_INVENTORY
				ICONINDEX_SETTINGS
		)
		(gGame setCursor: 996)
	)
	
	(method (handsOn fRestore)
		(gIconBar enable:)
		(gUser canControl: 1 canInput: 1)
		(gIconBar
			enable:
				ICONINDEX_WALK
				ICONINDEX_LOOK
				ICONINDEX_DO
				ICONINDEX_TALK
				; ICONINDEX_CUSTOM // see below
				ICONINDEX_CURITEM
				ICONINDEX_INVENTORY
				ICONINDEX_SETTINGS
		)
		(gIconBar disable: ICONINDEX_CUSTOM)
		; See above
		(if (and argc fRestore) (RestorePreviousHandsOn))
		(if (not (gIconBar curInvIcon?))
			(gIconBar disable: ICONINDEX_CURITEM)
		)
		(if gCurrentIcon
			(gIconBar curIcon: gCurrentIcon)
			(gGame setCursor: (gCurrentIcon cursor?))
			(= gCurrentIcon 0)
			(if
				(and
					(== (gIconBar curIcon?) (gIconBar at: 5))
					(not (gIconBar curInvIcon?))
				)
				(gIconBar advanceCurIcon:)
			)
		)
		(gGame setCursor: ((gIconBar curIcon?) cursor?) 1)
		(= gCursorNumber ((gIconBar curIcon?) cursor?))
	)
	
	(method (showAbout)
		((ScriptID ABOUT_SCRIPT 0) doit:)
		(DisposeScript ABOUT_SCRIPT)
	)
	
	(method (showControls &tmp temp0)
		(= temp0 ((gIconBar curIcon?) cursor?))
		((ScriptID GAMECONTROLS_SCRIPT 0) doit:)
		(gGameControls dispose:)
		(gGame setCursor: temp0 1)
	)
)

(instance icon0 of IconItem
	(properties
		view 990
		loop 0
		cel 0
		cursor 980
		type $5000
		message V_WALK
		signal $0041
		maskView 990
		maskLoop 13
		noun N_MOVEICON
		helpVerb V_HELP
	)
	
	(method (init)
		(= lowlightColor gLowlightColor)
		(super init:)
	)
	
	(method (select &tmp temp0)
		(return
			(if (super select: &rest)
				(gIconBar hide:)
				(return 1)
			else
				(return 0)
			)
		)
	)
)

(instance icon1 of IconItem
	(properties
		view 990
		loop 1
		cel 0
		cursor 981
		message V_LOOK
		signal $0041
		maskView 990
		maskLoop 13
		noun N_EXAMINEICON
		helpVerb V_HELP
	)
	
	(method (init)
		(= lowlightColor gLowlightColor)
		(super init:)
	)
)

(instance icon2 of IconItem
	(properties
		view 990
		loop 2
		cel 0
		cursor 982
		message V_DO
		signal $0041
		maskView 990
		maskLoop 13
		noun N_DOICON
		helpVerb V_HELP
	)
	
	(method (init)
		(= lowlightColor gLowlightColor)
		(super init:)
	)
)

(instance icon3 of IconItem
	(properties
		view 990
		loop 3
		cel 0
		cursor 983
		message V_TALK
		signal $0041
		maskView 990
		maskLoop 13
		maskCel 4
		noun N_TALKICON
		helpVerb V_HELP
	)
	
	(method (init)
		(= lowlightColor gLowlightColor)
		(super init:)
	)
)

; Use this icon for whatever action you want
(instance icon4 of IconItem
	(properties
		view 990
		loop 10       ; This is currently a loop with "empty" cels
		cel 0
		cursor 999     ; The cursor view associated with your action.
		message 0     ; The verb associated with this action.
		signal $0041
		maskView 990
		maskLoop 13
		maskCel 4
		noun 0 ; The noun for your button
		helpVerb V_HELP
	)
	
	(method (init)
		(= lowlightColor gLowlightColor)
		(super init:)
	)
)

(instance icon6 of IconItem
	(properties
		view 990
		loop 4
		cel 0
		cursor 999
		message 0
		signal $0041
		maskView 990
		maskLoop 13
		maskCel 4
		noun N_INVENTORYICON
		helpVerb V_HELP
	)
	
	(method (init)
		(= lowlightColor gLowlightColor)
		(super init:)
	)
	
	(method (select param1 &tmp newEvent temp1 currentInvIcon temp3 temp4)
		(return
			(cond 
				((& signal icDISABLED) 0)
				((and argc param1 (& signal notUpd))
					(= currentInvIcon (gIconBar curInvIcon?))
					(if currentInvIcon
						(= temp3
							(+
								(/
									(-
										(- nsRight nsLeft)
										(CelWide (currentInvIcon view?) 2 (currentInvIcon cel?))
									)
									2
								)
								nsLeft
							)
						)
						(= temp4
							(+
								(+
									(gIconBar y?)
									(/
										(-
											(- nsBottom nsTop)
											(CelHigh (currentInvIcon view?) 2 (currentInvIcon cel?))
										)
										2
									)
								)
								nsTop
							)
						)
					)
					(= temp1 1)
					(DrawCel view loop temp1 nsLeft nsTop -1)
					(= currentInvIcon (gIconBar curInvIcon?))
					(if currentInvIcon
						(DrawCel
							((= currentInvIcon (gIconBar curInvIcon?)) view?)
							2
							(currentInvIcon cel?)
							temp3
							temp4
							-1
						)
					)
					(Graph grUPDATE_BOX nsTop nsLeft nsBottom nsRight 1)
					(while (!= ((= newEvent (Event new:)) type?) 2)
						(newEvent localize:)
						(cond 
							((self onMe: newEvent)
								(if (not temp1)
									(= temp1 1)
									(DrawCel view loop temp1 nsLeft nsTop -1)
									(= currentInvIcon (gIconBar curInvIcon?))
									(if currentInvIcon
										(DrawCel
											((= currentInvIcon (gIconBar curInvIcon?)) view?)
											2
											(currentInvIcon cel?)
											temp3
											temp4
											-1
										)
									)
									(Graph grUPDATE_BOX nsTop nsLeft nsBottom nsRight 1)
								)
							)
							(temp1
								(= temp1 0)
								(DrawCel view loop temp1 nsLeft nsTop -1)
								(= currentInvIcon (gIconBar curInvIcon?))
								(if currentInvIcon
									(DrawCel
										((= currentInvIcon (gIconBar curInvIcon?)) view?)
										2
										(currentInvIcon cel?)
										temp3
										temp4
										-1
									)
								)
								(Graph grUPDATE_BOX nsTop nsLeft nsBottom nsRight 1)
							)
						)
						(newEvent dispose:)
					)
					(newEvent dispose:)
					(if (== temp1 1)
						(DrawCel view loop 0 nsLeft nsTop -1)
						(= currentInvIcon (gIconBar curInvIcon?))
						(if currentInvIcon
							(DrawCel
								((= currentInvIcon (gIconBar curInvIcon?)) view?)
								2
								(currentInvIcon cel?)
								temp3
								temp4
								-1
							)
						)
						(Graph grUPDATE_BOX nsTop nsLeft nsBottom nsRight 1)
					)
					temp1
				)
				(else 1)
			)
		)
	)
)

(instance icon7 of IconItem
	(properties
		view 990
		loop 5
		cel 0
		cursor 999
		type $0000
		message 0
		signal $0043
		maskView 990
		maskLoop 13
		noun N_SELECTINVICON2
		helpVerb V_HELP
	)
	
	(method (init)
		(= lowlightColor gLowlightColor)
		(super init:)
	)
	
	(method (select &tmp theGCursorNumber)
		(return
			(if (super select: &rest)
				(gIconBar hide:)
				(= theGCursorNumber gCursorNumber)
				(gInv showSelf: gEgo)
				(gGame setCursor: theGCursorNumber 1)
				(return 1)
			else
				(return 0)
			)
		)
	)
)

(instance icon8 of IconItem
	(properties
		view 990
		loop 7
		cel 0
		cursor 999
		message V_COMBINE
		signal $0043
		maskView 990
		maskLoop 13
		noun N_SETTINGSICON
		helpVerb V_HELP
	)
	
	(method (init)
		(= lowlightColor gLowlightColor)
		(super init:)
	)
	
	(method (select)
		(return
			(if (super select: &rest)
				(gIconBar hide:)
				(gGame showControls:)
				(return 1)
			else
				(return 0)
			)
		)
	)
)

(instance icon9 of IconItem
	(properties
		view 990
		loop 9
		cel 0
		cursor 989
		type evHELP
		message V_HELP
		signal $0003
		maskView 990
		maskLoop 13
		noun N_HELPICON
		helpVerb V_HELP
	)
	
	(method (init)
		(= lowlightColor gLowlightColor)
		(if gDialog (gDialog dispose:))
		(super init:)
	)
)

(instance checkIcon of Code
	(properties)
	
	(method (doit param1)
		(if
			(and
				(param1 isKindOf: IconItem)
				(& (param1 signal?) $0004)
			)
			(= gCheckedIcons
				(| gCheckedIcons (>> $8000 (gIconBar indexOf: param1)))
			)
		)
	)
)

(instance lb2DoVerbCode of Code
	(properties)
	
	(method (doit theVerb param2)
		(if (User canControl:)
			(if (== param2 gEgo)
				(if (Message msgSIZE 0 N_EGO theVerb 0 1)
					(gMessager say: N_EGO theVerb 0 0 0 0)
				else
					(gMessager say: N_EGO 0 0 (Random 1 2) 0 0)
				)
			else
				(switch theVerb
					(V_DO (gMessager say: 0 V_DO 0 (Random 1 2) 0 0))
					(V_TALK
						(gMessager say: 0 V_TALK 0 (Random 1 2) 0 0)
					)
					(V_AUDIOTOUR
						(gMessager say: 0 V_AUDIOTOUR 0 (Random 1 2) 0 0)
					)
					(else 
						(if (not (IsOneOf theVerb V_LOOK))
							(gMessager say: 0 V_COMBINE 0 (Random 2 3) 0 0)
						)
					)
				)
			)
		)
	)
)

(instance lb2FtrInit of Code
	(properties)
	
	(method (doit param1)
		(if (== (param1 sightAngle?) $6789)
			(param1 sightAngle: 90)
		)
		(if (== (param1 actions?) $6789) (param1 actions: 0))
		(if
			(and
				(not (param1 approachX?))
				(not (param1 approachY?))
			)
			(param1 approachX: (param1 x?) approachY: (param1 y?))
		)
	)
)

; This converts verbs into a bit flag mask
(instance lb2ApproachCode of Code
	(properties)
	
	(method (doit param1)
		(switch param1
			(V_LOOK 1)
			(V_TALK 2)
			(V_WALK 4)
			(V_DO 8)
			(31 16)
			(29 64)
			(25 128)
			(else  $8000)
		)
	)
)

(instance sq5Win of BorderWindow
	(properties)
)

(instance sQ5Narrator of Narrator
	(properties)
	
	(method (init)
		(= font gFont)
		(self back: gColorWindowBackground)
		(super init: &rest)
	)
)

(instance testMessager of Messager
	(properties)
	
	(method (findTalker talkerNumber &tmp temp0)
		(= gCurrentTalkerNumber talkerNumber)
		(= temp0
			(switch talkerNumber
				(NARRATOR gNarrator)
				(COMPUTER (ScriptID 210 2))                   ; Script 210, export 2
				(FLOWER (ScriptID 210 1))                   ; Script 210, export 1
				(WORM (ScriptID 210 3))                   ; Script 210, export 1
				(YOUTHINK (ScriptID YOUTHINK_SRIPT 0))
				(AUDIOGUIDE (ScriptID AUDIOGUIDE_SCRIPT 0))
				(DEATHWOMAN (ScriptID DEATHWOMANTALKER_SCRIPT 0))
			)
		)
		(if temp0
			(if (not (temp0 isKindOf: Narrator))
				(Prints {Invalid talker.})
			)
			(return temp0)
		else
			(return (super findTalker: talkerNumber))
		)
	)
)
