;;; Sierra Script 1.0 - (do not remove this comment)
(script# 921)
(include sci.sh)
(use Main)
(use DColorButton)
(use Controls)
(use DIcon)
(use System)
(public
	Prints 0
	Printf 1
	GetInput 2
	FindFormatLen 3
)

(procedure (Prints)
	(Print addText: &rest init:)
)

(procedure (Printf)
	(Print addTextF: &rest init:)
)

(procedure (GetInput theText theMax theMessage theFont)
	(if
		(Print
			font: (if (> argc 3) theFont else gFont)
			addText:
				(if (and (> argc 2) theMessage) theMessage else {})
			addEdit: theText theMax 0 12 theText
			init:
		)
		(StrLen theText)
	)
)

(procedure (FindFormatLen theText param2 &tmp temp0 temp1 temp2 temp3)
	(= temp1 (StrLen theText))
	(= temp0 temp1)
	(= temp2 0)
	(= temp3 0)
	(while (< temp3 temp1)
		(if (== (StrAt theText temp3) 37)                      ; %
			(switch (StrAt theText (++ temp3))
				(KEY_d (= temp0 (+ temp0 5)))
				(KEY_x (= temp0 (+ temp0 4)))
				(KEY_s (= temp0 (+ temp0 (StrLen [param2 temp2]))))
			)
			(++ temp2)
		)
		(++ temp3)
	)
	(return (++ temp0))
)

(class Print of Object
	(properties
		dialog 0
		window 0
		title 0
		mode 0
		font -1
		width 0
		x -1
		y -1
		ticks 0
		caller 0
		retValue 0
		modeless 0
		first 0
		saveCursor 0
	)
	
	(method (init theCaller)
		(= caller 0)
		(if argc (= caller theCaller))
		(if (> argc 1) (self addText: &rest))
		(if (not modeless)
			(if (not (IsObject gPrints))
				(= gPrints
					((EventHandler new:) name: {prints})
				)
			)
			(gPrints add: self)
		)
		(self showSelf:)
	)
	
	(method (doit)
		(dialog eachElementDo: #doit)
	)
	
	(method (dispose)
		(if
			(and
				gPrints
				(gPrints contains: self)
			)
			(gPrints delete: self)
			(if (gPrints isEmpty:)
				(gPrints dispose:)
				(= gPrints NULL)
			)
		)
		(if title (Memory memFREE title))
		(= width
			(= mode
				(= title (= first (= saveCursor (= window 0))))
			)
		)
		(= x (= y -1))
		(= modeless 0)
		(gSounds pause: 0)
		(super dispose:)
	)
	
	(method (showSelf &tmp theFirst temp1 temp2 temp3 temp4)
		(if saveCursor (gGame setCursor: 999))
		(if (not dialog) (= dialog (Dialog new:)))
		(dialog
			window: (if window else gWindow)
			name: {PODialog}
			caller: self
		)
		(dialog text: title time: ticks setSize:)
		(dialog center:)
		(= temp3 (if (== x -1) (dialog nsLeft?) else x))
		(= temp4 (if (== y -1) (dialog nsTop?) else y))
		(dialog moveTo: temp3 temp4)
		(= temp1 (GetPort))
		(dialog open: (if title nwTITLE else nwNORMAL) 15)
		(return
			(if modeless
				(= gOldPort (GetPort))
				(SetPort temp1)
				(= gDialog dialog)
			else
				(gSounds pause: 1)
				(= theFirst first)
				(cond 
					((not theFirst)
						(= theFirst (dialog firstTrue: #checkState 1))
						(if (and theFirst (not (dialog firstTrue: #checkState 2)))
							(theFirst state: (| (theFirst state?) $0002))
						)
					)
					((not (IsObject theFirst)) (= theFirst (dialog at: theFirst)))
				)
				(= retValue (dialog doit: theFirst))
				(SetPort temp1)
				(cond 
					((== retValue -1) (= retValue 0))
					((and (IsObject retValue) (retValue isKindOf: DButton)) (= retValue (retValue value?)))
					((not (dialog theItem?)) (= retValue 1))
				)
				(if saveCursor
					(gGame setCursor: ((gIconBar curIcon?) cursor?))
				)
				(dialog dispose:)
				(return retValue)
			)
		)
	)
	
	; addButton (theValue noun verb cond seq x y modNum)
	; addButton (theValue theText x y)
	(method (addButton theValue params &tmp noun verb case seq x y modNum text temp8)
		(if (not dialog) (= dialog (Dialog new:)))
		(if (== font -1) (= font gFont))
		(if (> argc 4)
			(= noun [params 0])
			(= verb [params 1])
			(= case [params 2])
			(= seq (if [params 3] [params 3] else 1))
			(= x 0)
			(= y 0)
			(= modNum gRoomNumber)
			(if (> argc 5)
				(= x [params 4])
				(if (> argc 6)
					(= y [params 5])
					(if (> argc 7) (= modNum [params 6]))
				)
			)
			(= temp8 (Message msgSIZE modNum noun verb case seq))
			(if temp8
				(= text
					(Memory
						memALLOC_CRIT
						(= temp8 (Message msgSIZE modNum noun verb case seq))
					)
				)
				(if (not (Message msgGET modNum noun verb case seq text))
					(= text 0)
				)
			)
		else
			(= x 0)
			(= y 0)
			(if (> argc 2)
				(= x [params 1])
				(if (> argc 3) (= y [params 2]))
			)
			(= text
				(Memory memALLOC_CRIT (+ (StrLen [params 0]) 1))
			)
			(StrCpy text [params 0])
		)
		(if text
			(dialog
				add:
					((DButton new:)
						value: theValue
						font: font
						text: text
						setSize:
						moveTo: (+ 4 x) (+ 4 y)
						yourself:
					)
				setSize:
			)
		)
	)
	
	; addColorButton(theValue noun verb cond seq x y modNum)
	; addColorButton(theValue noun verb cond seq x y modNum normalForeColor highlightForeColor selectedForeColor normalBackColor highlightBackColor selectedBackColor)
	(method (addColorButton theValue params &tmp noun verb case seq x y modNum temp7 temp8 normalForeColor normalBackColor highlightForeColor highlightBackColor selectedForeColor selectedBackColor)
		(if (not dialog) (= dialog (Dialog new:)))
		(if (== font -1) (= font gFont))
		(= normalForeColor 0)
		(= highlightForeColor 15)
		(= selectedForeColor 31)
		(= normalBackColor 5)
		(= highlightBackColor 5)
		(= selectedBackColor 5)
		(if (< (Abs [params 0]) 1000)
			(= noun [params 0])
			(= verb [params 1])
			(= case [params 2])
			(= seq (if [params 3] [params 3] else 1))
			(= x 0)
			(= y 0)
			(= modNum gRoomNumber)
			(if (> argc 5)
				(= x [params 4])
				(if (> argc 6)
					(= y [params 5])
					(if (> argc 7)
						(= modNum [params 6])
						(if (> argc 8)
							(= normalForeColor [params 7])
							(if (> argc 9)
								(= highlightForeColor [params 8])
								(if (> argc 10)
									(= selectedForeColor [params 9])
									(if (> argc 11)
										(= normalBackColor [params 10])
										(if (> argc 12)
											(= highlightBackColor [params 11])
											(if (> argc 13) (= selectedBackColor [params 12]))
										)
									)
								)
							)
						)
					)
				)
			)
			(= temp8 (Message msgSIZE modNum noun verb case seq))
			(if temp8
				(= temp7
					(Memory
						memALLOC_CRIT
						(= temp8 (Message msgSIZE modNum noun verb case seq))
					)
				)
				(if (not (Message msgGET modNum noun verb case seq temp7))
					(= temp7 0)
				)
			)
		else
			(= x 0)
			(= y 0)
			(if (> argc 2)
				(= x [params 1])
				(if (> argc 3)
					(= y [params 2])
					(if (> argc 4)
						(= normalForeColor [params 3])
						(if (> argc 5)
							(= highlightForeColor [params 4])
							(if (> argc 6)
								(= selectedForeColor [params 5])
								(if (> argc 7)
									(= normalBackColor [params 6])
									(if (> argc 8)
										(= highlightBackColor [params 7])
										(if (> argc 9) (= selectedBackColor [params 8]))
									)
								)
							)
						)
					)
				)
			)
			(= temp7
				(Memory memALLOC_CRIT (+ (StrLen [params 0]) 1))
			)
			(StrCpy temp7 [params 0])
		)
		(if temp7
			(dialog
				add:
					((DColorButton new:)
						value: theValue
						font: font
						text: temp7
						mode: mode
						nfc: normalForeColor
						nbc: normalBackColor
						sfc: selectedForeColor
						sbc: selectedBackColor
						hfc: highlightForeColor
						hbc: highlightBackColor
						setSize: width
						moveTo: (+ 4 x) (+ 4 y)
						yourself:
					)
				setSize:
			)
		)
	)
	
	; addEdit(theBuffer maxLength [x] [y] [initialText])
	(method (addEdit theBuffer maxLength x y initialText &tmp theX theY)
		(if (not dialog) (= dialog (Dialog new:)))
		(StrCpy theBuffer (if (> argc 4) initialText else {}))
		(if (> argc 2) (= theX x) (if (> argc 3) (= theY y)))
		(dialog
			add:
				((DEdit new:)
					text: theBuffer
					max: maxLength
					setSize:
					moveTo: (+ theX 4) (+ theY 4)
					yourself:
				)
			setSize:
		)
	)
	
	(method (addIcon theView theLoop theCel theX theY &tmp temp0 temp1)
		(if (not dialog) (= dialog (Dialog new:)))
		(if (> argc 3)
			(= temp0 theX)
			(= temp1 theY)
		else
			(= temp1 0)
			(= temp0 temp1)
		)
		(if (IsObject theView)
			(dialog
				add:
					(theView
						setSize:
						moveTo: (+ temp0 4) (+ temp1 4)
						yourself:
					)
				setSize:
			)
		else
			(dialog
				add:
					((DIcon new:)
						view: theView
						loop: theLoop
						cel: theCel
						setSize:
						moveTo: (+ temp0 4) (+ temp1 4)
						yourself:
					)
				setSize:
			)
		)
	)
	
	; addText (noun verb cond seq x y modNum)
	; addText (theText x y)
	(method (addText params &tmp noun verb case seq x y modNum text temp8)
		(if (not dialog) (= dialog (Dialog new:)))
		(if (== font -1) (= font gFont))
		(if (> argc 3)
			(= noun [params 0])
			(= verb [params 1])
			(= case [params 2])
			(= seq (if [params 3] [params 3] else 1))
			(= x 0)
			(= y 0)
			(= modNum gRoomNumber)
			(if (>= argc 5)
				(= x [params 4])
				(if (>= argc 6)
					(= y [params 5])
					(if (>= argc 7) (= modNum [params 6]))
				)
			)
			(= temp8 (Message msgSIZE modNum noun verb case seq))
			(if temp8
				(= text
					(Memory
						memALLOC_CRIT
						(= temp8 (Message msgSIZE modNum noun verb case seq))
					)
				)
				(if (Message msgGET modNum noun verb case seq text)
					(dialog
						add:
							((DText new:)
								text: text
								font: font
								mode: mode
								setSize: width
								moveTo: (+ 4 x) (+ 4 y)
								yourself:
							)
						setSize:
					)
				)
			)
		else
			(= x 0)
			(= y 0)
			(if (>= argc 2)
				(= x [params 1])
				(if (>= argc 3) (= y [params 2]))
			)
			(= text
				(Memory memALLOC_CRIT (+ (StrLen [params 0]) 1))
			)
			(StrCpy text [params 0])
			(dialog
				add:
					((DText new:)
						text: text
						font: font
						mode: mode
						setSize: width
						moveTo: (+ 4 x) (+ 4 y)
						yourself:
					)
				setSize:
			)
		)
	)
	
	(method (addTextF &tmp temp0 temp1)
		(= temp0 (FindFormatLen &rest))
		(= temp1 (Memory memALLOC_CRIT temp0))
		(Format temp1 &rest)
		(self addText: temp1)
		(Memory memFREE temp1)
	)
	
	; addTitle (noun verb cond seq modNum)
	; addTitle (theText)
	(method (addTitle params &tmp noun verb case seq modNum temp5)
		(if (> argc 1)
			(= noun [params 0])
			(= verb [params 1])
			(= case [params 2])
			(= seq [params 3])
			(= modNum [params 4])
			(= temp5 (Message msgSIZE modNum noun verb case seq))
			(if temp5
				(= title
					(Memory
						memALLOC_CRIT
						(= temp5 (Message msgSIZE modNum noun verb case seq))
					)
				)
				(Message msgGET modNum noun verb case seq title)
			)
		else
			(= title
				(Memory memALLOC_CRIT (+ (StrLen [params 0]) 1))
			)
			(StrCpy title [params 0])
		)
	)
	
	(method (posn theX theY)
		(= x theX)
		(= y theY)
	)
	
	(method (handleEvent pEvent)
		(if (dialog handleEvent: pEvent) (dialog dispose:))
	)
	
	(method (cue &tmp theCaller)
		(= theCaller caller)
		(= dialog 0)
		(if window (window dispose:))
		(self dispose:)
		(if theCaller (theCaller cue:))
	)
)
