;;; Sierra Script 1.0 - (do not remove this comment)
(script# 929)
(include sci.sh)
(use Main)
(use Timer)
(use Cycle)
(use System)


(class Sync of Object
	(properties
		syncTime -1
		syncCue $ffff
		prevCue $ffff
		syncNum -1
	)
	
	(method (syncStart param1 param2 param3 param4 param5)
		(DoSync 0 self param1 param2 param3 param4 param5)
		(if (!= syncCue -1) (= prevCue syncCue) (= syncTime 0))
	)
	
	(method (syncCheck)
		(if
			(and
				(!= syncCue -1)
				(or (u<= syncTime gSyncBias) (<= syncTime (DoAudio 6)))
			)
			(if (== (& $fff0 syncCue) 0)
				(= prevCue (| (& prevCue $fff0) syncCue))
			else
				(= prevCue syncCue)
			)
			(DoSync 1 self)
		)
	)
	
	(method (syncStop)
		(= prevCue -1)
		(DoSync 2)
	)
)

(class ScriptSync of Object
	(properties
		prevSignal -1
		playing 0
	)
	
	(method (init param1 param2 param3 param4 param5)
		(if gTheSync (self cue:))
		(= gTheSync (Sync new:))
		(gTheSync
			init:
			syncStart: param1 param2 param3 param4 param5
		)
		(if (!= (gTheSync prevCue?) -1)
			(= playing 1)
			(gRegions add: self)
		)
		(Timer
			setTicks:
				self
				(DoAudio 1 param1 param2 param3 param4 param5)
		)
	)
	
	(method (doit &tmp gNewSyncSyncTime)
		(if (!= (gTheSync prevCue?) -1)
			(repeat
				(breakif (== (gTheSync prevCue?) -1))
				(= gNewSyncSyncTime (gTheSync syncTime?))
				(gTheSync syncCheck:)
				(breakif (== gNewSyncSyncTime (gTheSync syncTime?)))
			)
			(= prevSignal (gTheSync prevCue?))
		)
	)
	
	(method (cue)
		(Animate (gCast elements?) 0)
		(= playing 0)
		(= prevSignal 32767)
		(gRegions delete: self)
		(if gTheSync
			(gTheSync syncStop: dispose:)
			(= gTheSync 0)
		)
	)
)

(class MouthSync of Cycle
	(properties
		client 0
		caller 0
		cycleDir 1
		cycleCnt 0
		completed 0
	)
	
	(method (init param1 param2 param3 param4 param5 param6)
		(super init: param1)
		(if (IsObject gTheSync) (gTheSync syncStop: dispose:))
		(= gTheSync (Sync new:))
		(gTheSync syncStart: param2 param3 param4 param5 param6)
	)
	
	(method (doit &tmp temp0 gNewSyncSyncTime_2 gNewSyncSyncTime temp3)
		(super doit:)
		(if (!= (gTheSync prevCue?) -1)
			(= gNewSyncSyncTime (gTheSync syncTime?))
			(= temp3 0)
			(repeat
				(= gNewSyncSyncTime_2 (gTheSync syncTime?))
				(gTheSync syncCheck:)
				(breakif (== gNewSyncSyncTime_2 (gTheSync syncTime?)))
			)
			(if
				(and
					(!= gNewSyncSyncTime (gTheSync syncTime?))
					(!=
						(client cel?)
						(= temp0 (& $000f (gTheSync prevCue?)))
					)
				)
				(client cel: temp0)
			)
		else
			(= completed 1)
			(self cycleDone:)
		)
	)
	
	(method (dispose)
		(super dispose:)
		(if gTheSync (gTheSync dispose:) (= gTheSync 0))
	)
	
	(method (cue)
		(if gTheSync
			(gTheSync syncStop: dispose:)
			(= gTheSync 0)
			(if caller (caller cue:) (= caller 0))
		)
	)
)
