;;; Sierra Script 1.0 - (do not remove this comment)

(script# DEATH_REGION)
(include sci.sh)
(include game.sh)
(include 802.shm)
(use Game)
(use View)
(use System)
(use Main)
(use Cycle)
(use Sound)
(use Controls)
(use Print)
(use Oscillate)
(use Conversation)

(public

	deathRegion 0
)
(define APPROACH_DISTANCE 18)
(define APPROACH_DISTANCE_Y 18)
(define SCREEN_OFFSET_Y 3)
(define CHOICE_NODEATH 100)
(local
	ScreenX =  0
	ScreenY =  0
	ScreenHeight =  0
	ScreenShowing =  FALSE
	[DeathChoices 2]
	DeathReason
	[DeathReasonToView 6] = [0 801 802 803 804 805]
	ApproachDistanceY
)
; When you approach, the screen rises.
(instance deathRegion of Region
	(properties
		keep FALSE
	)
	
	(method (init)
		(super init: &rest)
		(= ApproachDistanceY APPROACH_DISTANCE_Y)
		(= ScreenHeight
			(CelHigh (deathScreen view?) (deathScreen loop?) 0)
		)
		(switch gNewRoomNumber
			; Position of screen in various rooms:
			(401
				(= ScreenX 108)
				(= ScreenY 75)
				(= [DeathChoices  0] DEATH_FREEZING)
				(= [DeathChoices  1] DEATH_HEADEXPLOSION)
			)
			(141
				(= ScreenX 131)
				(= ScreenY 66)
				(= [DeathChoices  0] DEATH_HEADEXPLOSION)
				(= [DeathChoices  1] DEATH_MELTING)
			)
			(400
				(= ScreenX 251)
				(= ScreenY 51)
				(= [DeathChoices  0] DEATH_ELECTROCUTION)
				(= [DeathChoices  1] DEATH_FREEZING)
			)
			(136
				(= ScreenX 196)
				(= ScreenY 91)
				(= [DeathChoices  0] DEATH_FLATTENING)
				(= [DeathChoices  1] DEATH_ELECTROCUTION)
				(= ApproachDistanceY 40)             ; Special case
				(deathScreen setPri: 4)
			)
		)             ; Special case
		(screenSupport
			posn: ScreenX (+ ScreenY SCREEN_OFFSET_Y)
			approachY: (+ ScreenY 10)
			approachX: ScreenX
			approachVerbs: V_LOOK V_DO
			init:
		)
		(deathScreen
			ignoreControl: ctlWHITE                    ; We have some "legacy" pics with white control lines.
			posn: ScreenX (+ ScreenY ScreenHeight)
			approachY: (+ ScreenY 10)
			approachX: ScreenX
			approachVerbs: V_LOOK V_DO V_TALK
			init:
			hide:
		)
		(self setScript: screenScript)
	)
)

(instance screenScript of Script
	(properties)
	
	(method (doit &tmp shouldShow)
		(super doit:)
		(= shouldShow FALSE)
		(if
			(<
				(Abs (- (gEgo x?) (screenSupport x?)))
				APPROACH_DISTANCE
			)
			(if
				(<
					(Abs (- (gEgo y?) (screenSupport y?)))
					ApproachDistanceY
				)
				(= shouldShow TRUE)
			)
		)
		(if (!= ScreenShowing shouldShow)
			(if shouldShow
				(deathScreen setScript: showScreenScript)
			else
				(deathScreen setScript: hideScreenScript)
			)
			(= ScreenShowing shouldShow)
		)
	)
	
	(method (changeState newState)
		(= state newState)
		(switch state
			(0)
		)
	)
)

(instance hideScreenScript of Script
	(properties)
	
	(method (changeState newState)
		(= state newState)
		(switch state
			(0
				(deathScreen
					setMotion:
						MoveTo
						(deathScreen x?)
						(+ ScreenY ScreenHeight)
						self
				)
			)
			(1
				(self dispose:)
				(deathScreen setCycle: NULL)
				(deathScreen hide:)
			)
		)
	)
)

(instance showScreenScript of Script
	(properties)
	
	(method (changeState newState)
		(= state newState)
		(switch state
			(0
				(deathScreen show:)
				(deathScreen
					setMotion: MoveTo (deathScreen x?) ScreenY self
				)
			)
			(1 (deathScreen setCycle: Forward) (self dispose:))
		)
	)
)

(instance deathScreen of Actor
	(properties
		view 1005
		loop 0
		x 150
		y 100
		yStep 3
		noun N_SCREEN
		; For objects that aren't defined in the current room, we can explicltly
		; set modNum in order to specify which message resource messages are pulled from.
		modNum scriptNumber
		priority 0
		signal (| fixPriOn ignAct)
	)
	
	(method (doVerb theVerb)
		(switch theVerb
			(V_TALK (deathRegion setScript: offerDeathOptionsScript))
			(V_DO (deathRegion setScript: offerDeathOptionsScript))
			(else  (super doVerb: theVerb &rest))
		)
	)
)

(instance offerDeathOptionsScript of Script
	(properties)
	
	(method (changeState newState &tmp result)
		(= state newState)
		(switchto state
			(
				; We want speech, but also a dialog with dynamic choices.
				; We'll create a conversation first, then we'll display the dialog.
				(deathConv add: scriptNumber N_SCREEN V_TALK 0 0)
				(deathConv add: scriptNumber N_DEATH 0 [DeathChoices 0] 0)
				(deathConv add: scriptNumber N_DEATH 0 [DeathChoices 1] 0)
				(deathConv init: self)
			)
			
			(
				(= result
					(Print
						addIcon: 1006 0 0 0 0
						addText: N_SCREEN V_TALK 0 0 60 0 scriptNumber
						addButton:
							[DeathChoices 0]
							N_DEATH
							0
							[DeathChoices 0]
							0
							70
							35
							scriptNumber
						addButton:
							[DeathChoices 1]
							N_DEATH
							0
							[DeathChoices 1]
							0
							70
							50
							scriptNumber
						addButton: CHOICE_NODEATH N_DEATH 0 0 0 70 65 scriptNumber
						init:
					)
				)
				(ScoreFlag (+ F_DeathType [DeathChoices 0]) 2)
				(ScoreFlag (+ F_DeathType [DeathChoices 1]) 2)
				(if (== result CHOICE_NODEATH)
					(self dispose:)
					(deathRegion setScript: screenScript)
					(gMessager say: N_SCREEN V_TALK 3 0 0 scriptNumber)
				else
				
					; Create another conversation
					(deathConv add: scriptNumber N_SCREEN V_TALK 1 0)
					(deathConv add: scriptNumber N_DEATH 0 result 0)
					(deathConv add: scriptNumber N_SCREEN V_TALK 2 0)
					(deathConv init: self)
					
					(= DeathReason result)
				)
			)
			
			(
				(= result
					(Print
						addIcon: 1006 0 0 0 0
						addText: N_SCREEN V_TALK 1 0 60 0 scriptNumber
						addText: N_DEATH 0 result 0 70 25 scriptNumber
						addText: N_SCREEN V_TALK 2 0 60 40 scriptNumber
						addButton: 0 {Yes} 70 70
						addButton: 1 {No} 130 70
						init:
					)
				)
				(if (== result 1)
					(self dispose:)
					(deathRegion setScript: screenScript)
					(gMessager say: N_SCREEN V_TALK 3 0 0 scriptNumber)
				else
					(deathScreen setScript: hideScreenScript self)
				)
			)
			(
				(= seconds 2)
			)
			(
				(deathRegion setScript: anyDeathScript)
			)
		)
	)
)

(instance screenSupport of Prop
	(properties
		view 1005
		loop 1
		x 150
		y 100
		modNum scriptNumber
		noun N_BASE
	)
)

(instance anyDeathScript of Script
	(properties)
	
	(method (changeState newState)
		(= state newState)
		(switch state
			(0
				(DebugPrint
					{death reason is %d and view is %d}
					DeathReason
					[DeathReasonToView
					DeathReason]
				)
				(gGame handsOff:)
				(gEgo
					view: [DeathReasonToView DeathReason]
					cel: 0
					cycleSpeed: 8
				)
				(gEgo setCycle: EndLoop self)
			)
			(1 (= seconds 4))
			(2 (Die DeathReason))
		)
	)
)


(instance deathConv of Conversation
	(properties)
)