;;; Sierra Script 1.0 - (do not remove this comment)
(script# DEATH_SCRIPT)
(include sci.sh)
(include Verbs.sh)
(include game.sh)
(include 20.shm)
(use Main)
(use Cycle)
(use Game)
(use View)
(use System)
(public
	deathRoom 0
)
(local
	[messageBuffer 200]
	EyeIntensity =  0
)
(procedure (localproc_006e)
	(iWannaQuit init:)
	(iWannaRestore init:)
	(iWannaRestart init:)
	(gUser canControl: 1 canInput: 1)
	(gIconBar enable:)
	(gIconBar enable: ICONINDEX_DO)
	(gIconBar select: (gIconBar at: 2))
	(gGame setCursor: 999)
)

(instance deathRoom of Room
	(properties
		picture 800
	)
	
	(method (init)
		(Palette palSET_INTENSITY 0 240 100)
		(Palette palSET_INTENSITY 240 255 0)                             ; skull eyes
		(PalVary pvUNINIT)
		(gGame handsOff:)
		(super init:)
		(gMusic1 number: 46 play:)
		(gMusic2 stop:)
		(switch gDeathReason
			; TODO: Add special cases here
			(else  (gRoom setScript: sGeneric))
		)
	)
	
	(method (doVerb theVerb)
		(switch theVerb
			(V_DO)
			(else  (super doVerb: theVerb &rest))
		)
	)
)

(instance sGeneric of Script
	(properties)
	
	(method (changeState newState &tmp skullView)
		(switch (= state newState)
			(0
				(gGame handsOff:)
				(Message
					msgGET
					DEATH_SCRIPT
					N_DEATH
					0
					0
					gDeathReason
					@messageBuffer
				)
				(Display
					@messageBuffer
					dsCOORD
					60
					68
					dsCOLOR
					7
					dsBACKGROUND
					-1
					dsFONT
					1605
					dsWIDTH
					100
					dsALIGN
					alCENTER
				)
				(= skullView
					(switch gDeathReason
						(DEATH_HEADEXPLOSION 801)
						(DEATH_FREEZING 802)
						(DEATH_MELTING 803)
						(DEATH_ELECTROCUTION 804)
						(DEATH_FLATTENING 805)
					)
				)
				(skull
					view: skullView
					loop: 0
					cel: 0
					init:
					posn: 30 101
					setCycle: EndLoop
				)
				(= seconds 2)
			)
			(1 (localproc_006e) (self changeState: 2))
			(2 (= ticks 20))
			(3
				(++ EyeIntensity)
				(Palette palSET_INTENSITY 240 255 EyeIntensity)
				(if (== 100 EyeIntensity)
					(self dispose:)
				else
					(self changeState: 2)
				)
			)
		)
	)
)

(instance skull of Prop
	(properties
		signal $4000
	)
	
	(method (doVerb theVerb)
		(switch theVerb
			(V_DO)
			(else  (super doVerb: theVerb &rest))
		)
	)
)

(instance iWannaRestart of View
	(properties
		x 50
		y 170
		view 2099
		loop 1
	)
	
	(method (doVerb theVerb)
		(switch theVerb
			(V_DO (self cel: 1) (gGame restart:))
			(else  (super doVerb: theVerb &rest))
		)
	)
)

(instance iWannaRestore of View
	(properties
		x 115
		y 170
		view 2099
	)
	
	(method (doVerb theVerb)
		(switch theVerb
			(V_DO (self cel: 1) (gGame restore:))
			(else  (super doVerb: theVerb &rest))
		)
	)
)

(instance iWannaQuit of View
	(properties
		x 180
		y 170
		view 2099
		loop 2
	)
	
	(method (doVerb theVerb)
		(switch theVerb
			(V_DO (self cel: 1) (= gQuitGame TRUE))
			(else  (super doVerb: theVerb &rest))
		)
	)
)
