;;; Sierra Script 1.0 - (do not remove this comment)

(script# FLOPPYDISK_REGION)
(include sci.sh)
(include game.sh)
(include 800.shm)
(use Game)
(use View)
(use System)
(use Main)
(use Cycle)
(use Sound)
(use Controls)
(use Print)
(use Oscillate)
(public

	floppyRegion 0
)
(local
	PuzzlePieceId =  -1
)
(instance myDialog of Dialog
	(properties)
)

(instance floppyRegion of Region
	(properties
		keep FALSE
	)
	
	(method (init &tmp isSpecial)
		(super init: &rest)
		(= isSpecial FALSE)
		(switch gNewRoomNumber
			; Position of floppy drive in various rooms:
			(500 (floppyDrive posn: 38 149) (= PuzzlePieceId 0))
			(200 (floppyDrive posn: 253 118) (= PuzzlePieceId 1))
			(104
				(floppyDrive posn: 287 156)
				(if (Btest F_PressedRedButton)
					(= PuzzlePieceId 2)
					(= isSpecial TRUE)
					(floppyDrive setLoop: 1)
				else
					(= PuzzlePieceId 6)
				)
			)
			(402 (floppyDrive posn: 144 128 15) (= PuzzlePieceId 3))
			(110
				(floppyDrive posn: 125 98 33)                            ; Don't change the y/z (see room 110)
				(= PuzzlePieceId 7)
				(floppyDrive setLoop: 2)
				(floppyDrive setPri: 5)
			)
			(600 (floppyDrive posn: 181 134 42) (= PuzzlePieceId 8))
			(136
				(floppyDrive posn: 236 54 38 setPri: 0)
				(= PuzzlePieceId 4)
			)
			(404
				(floppyDrive posn: 229 124 37 setPri: 0)
				(floppyDrive setLoop: 2)
				(= PuzzlePieceId 5)
			)
		)
		(floppyDrive
			approachY: (floppyDrive y?)
			approachX: (+ (floppyDrive x?) 20)
			approachVerbs: V_LOOK V_DO V_FLOPPYDISK
			init:
			setCycle: (if (!= isSpecial TRUE) Forward else Oscillate)
		)
	)
)

(instance floppyDrive of Prop
	(properties
		view 6
		x 150
		y 100
		noun N_FLOPPYDRIVE
		; For objects that aren't defined in the current room, we can explicltly
		; set modNum in order to specify which message resource messages are pulled from.
		modNum scriptNumber
		signal ignAct
	)
	
	(method (doVerb theVerb)
		(switch theVerb
			(V_FLOPPYDISK (floppyRegion setScript: copyDataScript))
			(else  (super doVerb: theVerb &rest))
		)
	)
)

(instance copyDataScript of Script
	(properties)
	
	(method (changeState newState &tmp flagId)
		(= state newState)
		(switch state
			(0
				(gMessager
					say: N_FLOPPYDRIVE V_FLOPPYDISK 0 1 self scriptNumber
				)
			)
			(1 (floppyWriteSound play: self))
			; For some reason, the sound does not play.
			(2
				(= flagId (+ F_Puzzle_First PuzzlePieceId))
				(if (not (Btest flagId))
					(ScoreFlag flagId 5)
					(Print
						dialog: myDialog
						font: gFont
						width: 150
						mode: 1
						addIcon: 113 0 PuzzlePieceId 4 2
						addText: N_FLOPPYDRIVE V_FLOPPYDISK 0 2 4 35 scriptNumber
						init:
					)
				else
					(gMessager
						say: N_FLOPPYDRIVE V_FLOPPYDISK 0 3 self scriptNumber
					)
				)
			)
		)
	)
)

(instance floppyWriteSound of Sound
	(properties
		priority 15
		number 800
	)
)
