;;; Sierra Script 1.0 - (do not remove this comment)
(script# TITLEROOM_SCRIPT)
(include sci.sh)
(include game.sh)
(include Verbs.sh)
(include 0.shm)
(use Main)
(use Controls)
(use Print)
(use Cycle)
(use Game)
(use View)
(use System)
(public
	rm100 0
)

(instance myDialog of Dialog
	(properties)
)

(instance rm100 of Room
	(properties
		picture 300
	)
	
	(method (init)
		(SetPort 0 0 200 320 0 0)
		(Palette palSET_FROM_RESOURCE 999 2)
		(if gDialog (gDialog dispose:))
		(super init:)
		(gOldMH addToFront: self)
		(gOldKH addToFront: self)
		(gGame setCursor: 996 1)
		(gIconBar hide: disable:)
		(gUser canInput: TRUE)
		(self setScript: rmScript)
		
		; Use this to initialize the player's inventory
		(gEgo get: INV_AUDIOGUIDE)	; starts with an audio guide.
	)
	
	(method (dispose)
		(SetPort 0 0 190 320 10 0)
		(gIconBar hide: enable:)
		(= gNormalCursor 999)
		(Palette palSET_FROM_RESOURCE 999 2)
		(gGame setCursor: 996 1)
		(gOldKH delete: self)
		(gOldMH delete: self)
		(super dispose: &rest)
	)
	
	(method (handleEvent pEvent)
		(if
			(and
				(!= (rmScript state?) 4)
				(&
					(pEvent type?)
					(| evVERB (| evMOUSEBUTTON evKEYBOARD))
				)
			)
			; Skip to state 4 if the keyboard or mouse is used
			(rmScript changeState: 4)
			(pEvent claimed: 1)
			(return)
		else
			(super handleEvent: pEvent)
		)
	)
)

(instance rmScript of Script
	(properties)
	
	(method (doit)
		(super doit: &rest)
	)
	
	(method (changeState newState &tmp temp0 [temp1 10])
		(switch (= state newState)
			(0
				(PalVary pvINIT 300 4)
				(gMusic1 number: 1001 loop: 1 play:)
				(= seconds 4)
			)
			(1
				(PalVary pvUNINIT)
				(if (== (gMusic1 prevSignal?) 20)
				; sparkle removed
				else
					(-- state)
					(= cycles 1)
				)
			)
			(2
				(if (== (gMusic1 prevSignal?) 30)
				; sparkle removed
				else
					(-- state)
					(= cycles 1)
				)
			)
			(3 (= seconds 3))
			(4 (PalVary pvUNINIT) (gMusic1 stop:) (= cycles 5))
			(5
				(= seconds 0)
				(= gNormalCursor 999)
				(gGame setCursor: 999 1)
				(Print
					dialog: myDialog
					font: gFont
					width: 150
					mode: 1
					addText: N_TITLEMENU V_LOOK 0 4 0 0 0
					addText: N_TITLEMENU V_LOOK 0 5 0 10 0
					addColorButton: 0 N_TITLEMENU V_LOOK 0 1 0 37 0 0 15 23 5 5 5
					addColorButton: 1 N_TITLEMENU V_LOOK 0 2 0 52 0 0 15 23 5 5 5
				)
				(= temp0
					(Print
						addColorButton: 2 N_TITLEMENU V_LOOK 0 3 0 67 0 0 15 23 5 5 5
						init:
					)
				)
				(switch temp0
					(0 (gRoom newRoom: 110))
					(1
						(gGame restore:)
						(self changeState: state)
					)
					(2 (= gQuitGame TRUE))
				)
			)
		)
	)
)
