;;; Sierra Script 1.0 - (do not remove this comment)
(script# 106)
(include sci.sh)
(include game.sh)
(include 106.shm)
(include 106.shp)
(use Cycle)
(use Door)
(use Feature)
(use Game)
(use Main)
(use System)
(use Polygon)
(use View)
(public
	rm106 0
)
(define PAL_DARKEN_START 8)
(define PAL_DARKEN_END 64)
(define FADE_X 30)
(local
	[BrightSpots 3] = [101 151 202]
)
(instance rm106 of Room
	(properties
		picture scriptNumber
		north 105
		east 0
		south 110
		west 0
		noun N_ROOM
		; dpOPEN_FADEPALETTE will fade the intensities to zero, then back up to 100 for the new room.
		; This is necessary for us, since we could be coming from room 105, which has manually set intensities
		; to a low value for some of the palette range.
		; If we used dpOPEN_INSTANTLY instead, then we'd be left with the choice of either restoring the
		; palette intensities prior to (super:init()) (which would make room 105's tv screen flash brightly), or
		; after (super:init()) (which would make the current room flash incorrectly).		
		style dpOPEN_FADEPALETTE
	)

	(method (init)
		(AddPolygonsToRoom @P_Default106)
		(super init:)
		(self setScript: RoomScript)
		(switch gPreviousRoomNumber
			; Set up ego view and loop (direction)
			(north (SetUpEgo -1 2) (gEgo posn: 63 102))
			(south (SetUpEgo -1 3) (gEgo posn: 235 118))
			(else  (SetUpEgo -1 0) (gEgo posn: 128 110))
		)
		(gEgo init:)
	)
	
	(method (doit &tmp egoControl)
		(super doit:)
		(= egoControl (gEgo onControl:))
		(if (& ctlNAVY egoControl) (gRoom newRoom: north))
		(if (& ctlGREEN egoControl) (gRoom newRoom: south))
	)
)

(instance RoomScript of Script
	(properties)
	
	(method (doit &tmp egoIntensity egoX i distance tempIntensity)
		(super doit:)
		(= egoIntensity 100)
		(= egoX (gEgo x?))
		(for ( (= i 0)) (< i 3)  ( (++ i))
			(= distance (Abs (- egoX [BrightSpots i])))
			(if (< distance FADE_X)
				(= tempIntensity (/ (* distance 100) FADE_X))
				(if (< tempIntensity egoIntensity)
					(= egoIntensity tempIntensity)
				)
			)
		)
		(Palette
			palSET_INTENSITY
			PAL_DARKEN_START
			PAL_DARKEN_END
			egoIntensity
		)
	)
	
	(method (changeState newState)
		(= state newState)
		(switch state
			(0)
		)
	)
)
