;;; Sierra Script 1.0 - (do not remove this comment)
(script# 110)
(include sci.sh)
(include Verbs.sh)
(include game.sh)
(include 110.shm)
(include 110.shp)
(use Main)
(use DisposeLoad)
(use Sound)
(use Cycle)
(use Game)
(use View)
(use System)
(use Print)
(use Polygon)

(public
	rm110 0
)

(local
	WasOnBrown =  FALSE
)
(instance rm110 of Room
	(properties
		north 106
		picture 110
		style dpOPEN_FADEPALETTE
		horizon 50
		vanishingX 130
		vanishingY 50
		noun N_ROOM
	)
	
	(method (init &tmp initEgoNow)
		(= initEgoNow TRUE)
		(AddPolygonsToRoom @P_Default110)
		(self setRegions: FLOPPYDISK_REGION)
		(super init:)
		(SetUpEgo)
		(switch gPreviousRoomNumber
			(north
				(gEgo posn: 214 113 loop: 2)
			)
			(209
				(gEgo posn: 47 174 loop: 3)
			)
			(111
				(gEgo posn: 129 152 loop: 7)
			)
			(103
				(gEgo posn: 259 173 loop: 7)
			)
			(100
				(gEgo posn: 173 135 loop: 1)
			)
			(else 
				(gGame handsOff:)
				(SetUpEgo 2 0)
				(gEgo setCel: (gEgo lastCel:))
				(gEgo posn: 173 135)
				(self setScript: TransportInScript)
				(= initEgoNow FALSE)
			)
		)
		(gEgo init:)
		(lisa approachVerbs: V_DO V_FLOPPYDISK init:)
		(if (not (gEgo has: INV_FLOPPY))
			(aFloppy approachVerbs: V_DO V_LOOK init:)
		)
		(if initEgoNow (gGame handsOn:))
		(painting approachVerbs: V_DO V_LOOK init:)
	)
	
	(method (doit &tmp egoOnControl)
		(= egoOnControl (gEgo onControl:))
		(if (& ctlGREEN egoOnControl) (gRoom newRoom: north))
		(if (& ctlMAROON egoOnControl) (gRoom newRoom: 135))
		(if (& ctlPURPLE egoOnControl) (gRoom newRoom: 209))
		(if (& ctlBROWN egoOnControl)
			(cond 
				((Btest F_PressedGreenButton) (gRoom newRoom: 103))
				((not WasOnBrown) (gMessager say: N_SECRETEXIT 0 0))
			)
			(= WasOnBrown TRUE)
		)
	)
)

(instance lisa of Prop
	(properties
		view 5
		x 109
		y 138
		signal ignAct
		noun N_LISA
		approachX 133
		approachY 152
	)
	
	(method (doVerb theVerb)
		(switch theVerb
			(V_FLOPPYDISK
				(gRoom newRoom: 111)
			)
			(else 
				(super doVerb: theVerb &rest)
			)
		)
	)
)

(instance aFloppy of Prop
	(properties
		view 900
		loop 3
		x 235
		y 123
		signal (| ignAct fixPriOn)
		noun N_FLOPPYDISK
		priority 0
		approachDist 15
		approachX 215
		approachY 120
	)
	
	(method (doVerb theVerb)
		(switch theVerb
			(V_DO
				(gEgo get: INV_FLOPPY)
				(aFloppy hide:)
				(ScoreFlag F_PickedUpFloppy 2)
			)
			(else 
				(super doVerb: theVerb &rest)
			)
		)
	)
)

(instance TransportInScript of Script
	(properties)
	
	(method (changeState newState)
		(= state newState)
		(switch state
			(0
				(gEgo setCycle: BegLoop self)
			)
			(1
				(SetUpEgo 0 2)
				(gEgo init:)
				(gGame handsOn:)
			)
		)
	)
)
                                            ; Now floppy has click priority ; Now painting has click prioirty
(instance painting of Prop
	(properties
		view 120
		approachX 163
		approachY 103
		signal (| fixPriOn ignAct)
		noun N_PAINTING
		priority 6
	)
	
	(procedure (UpdatePainting)
		(if (Btest F_MovedPainting)
			(self setCel: 1 posn: 139 97 63)
		else
			(self setCel: 0 posn: 139 99 65)
		)
	)
	
	
	(method (init)
		(UpdatePainting)
		(super init: &rest)
	)
	
	(method (doVerb theVerb)
		(switch theVerb
			(V_DO
				(if (not (Btest F_MovedPaintingOnce))
					(gMessager say: N_PAINTING V_DO 0)
				)
				(ScoreFlag F_MovedPaintingOnce 2)
				(if (Btest F_MovedPainting)
					(Bclear F_MovedPainting)
				else
					(Bset F_MovedPainting)
				)
				(UpdatePainting)
			)
			(else 
				(super doVerb: theVerb &rest)
			)
		)
	)
)
