;;; Sierra Script 1.0 - (do not remove this comment)
(script# 1111)
(include sci.sh)
(include game.sh)
(include 1111.shm)
(include 1111.shp)
(use Cycle)
(use Door)
(use Feature)
(use Game)
(use Main)
(use Polygon)
(use Sound)
(use System)
(use Print)
(use View)

(public
	rm1111 0
)

(define CYCLE_SPEED 2)
(define STATIC_CYCLE_SPEED 1)
(define MAX_LETTERS 30)
(define TEXT_SPEED_CYCLES 8)

(local
	isStatic = FALSE
	currentLetter = 0
	charSave
	currentStringSize
	currentStringColor
	currentStringX
	currentStringY
	isTextSoundPaused = TRUE
	[currentLetters MAX_LETTERS]
)

(instance rm1111 of Room
	
	(properties
		picture scriptNumber
		north 0
		east 0
		south 0
		west 0
		noun N_ROOM
	)

	(method (init)
		(gIconBar hide: disable:)
		(SetPort 0 0 200 320 0 0)
		
		(AddPolygonsToRoom @P_Default1111)
		(super init:)
		(self setScript: RoomScript)
		; setVol does not appear to work. Maybe it doesn't work for audio resources.
		(computerFan play: setVol: 22)
		(textSound play: pause: TRUE)
	)
)

(instance RoomScript of Script
	

	
	(properties)
	(method (doit)
		(super doit:)
		
		(if (not isStatic)
			(Palette palANIMATE
				64 75 CYCLE_SPEED
				75 86 CYCLE_SPEED
				86 97 CYCLE_SPEED
				97 108 CYCLE_SPEED
				108 119 CYCLE_SPEED
				119 130 CYCLE_SPEED
				130 141 CYCLE_SPEED
				141 152 CYCLE_SPEED
				152 163 CYCLE_SPEED
				163 174 CYCLE_SPEED
				174 185 CYCLE_SPEED
				185 196 CYCLE_SPEED
				196 207 CYCLE_SPEED
				207 218 CYCLE_SPEED
				218 229 CYCLE_SPEED
				229 240 CYCLE_SPEED
			)
		else
			(Palette palANIMATE 64 255 STATIC_CYCLE_SPEED)
		)
	)
	
	(method (changeState newState)
		(= state newState)
		(switchto state
			(
				(= seconds 3)
			)
			(
				(self setScript: drawLettersScript {Subject Testing: COMPLETE} 45 14 15)
			)
			(
				(= seconds 3)
			)
			(
				(rm1111 drawPic: 1111)
				(self setScript: drawLettersScript {Test Result: PASS} 45 14 15)
			)
			(
				(= seconds 2)
			)
			(
				(self setScript: drawLettersScript {Recommendation: } 45 10 125)
			)
			(
				(= seconds 3)
			)
			(
				; make the button appear.
				(terminateButton init:)
				(= seconds 2)
				(textSound stop:)
			)
			(
				(alienHand init: setMotion: MoveTo 274 256 self)
			)
			(
				(= seconds 2)
			)
			(
				; re-use the sound and change it
				(textSound loop: 1  number: 229 play:)
				(terminateButton setCel: 1)
				(= seconds 2)
			)
			(
				; draw the pic to clear the text
				(rm1111 drawPic: 1111)
				(terminateButton hide:)
				
				; move the hand back, but don't cue
				(alienHand setMotion: MoveTo 287 324)
				
				; now fade to white
				(PalVary pvINIT 1112 1 64 2)
				(= seconds 2)
			)
			(
				(PalVary pvUNINIT)
				(computerFan stop:)
				(= cycles 4)
			)
			(
				; now draw the new pic of static
				(= isStatic TRUE)
				(rm1111 drawPic: 1112)
				(= seconds 4)
			)
			(
				(self setScript: drawLettersScript {... Signal Lost ...} 27 60 90)
			)
			(
				(= seconds 3)
			)
			(
				(rm1111 drawPic: 0)
				(= seconds 2)
			)
			(
				(RestartGame)
			)
		)
	)
)

(instance drawLettersScript of Script
	(properties)
	
	(method (init theClient originalLetters theColor theX theY)
		(= currentStringColor theColor)
		(= currentStringX theX)
		(= currentStringY theY)
		(= currentStringSize (StrLen originalLetters))
		(= register originalLetters)
		(= currentLetter 0)
		(= client theClient)
		(super init: theClient)
		(= charSave (StrAt @currentLetters currentLetter NULL))
	)
	
	(method (changeState newState)
		(= state newState)
		(switch state
			(0
				(StrCpy @currentLetters register MAX_LETTERS)
				(= cycles TEXT_SPEED_CYCLES)
			)
			(1
				; go to the next letter.
				(StrAt @currentLetters currentLetter charSave)	; replace the missing letter
				
				(if (!= charSave ` )
					(if isTextSoundPaused
						(textSound pause: FALSE)
						(= isTextSoundPaused FALSE)
					)
				else
					(if (not isTextSoundPaused)
						(textSound pause: TRUE)
						(= isTextSoundPaused TRUE)
					)
				)
				
				(++ currentLetter)
				(= charSave (StrAt @currentLetters currentLetter NULL)) ; grab the next one and replace with 0
				(if (> currentLetter currentStringSize)
					; we're done
					(textSound pause: TRUE)
					(= isTextSoundPaused TRUE)
					(client cue:)
					
				else
					(Display
						@currentLetters
						dsCOORD currentStringX currentStringY
						dsCOLOR currentStringColor
						dsFONT 1111
					)
					(self changeState: 0)
					
				)
			)
		)
			
	)
)

(instance computerFan of Sound
	(properties
		priority 15
		loop -1
		number 1111
	)
)

(instance alienHand of Actor
	(properties
		x 287
		y 324
		signal ignAct
		priority 15
		view 1111
	)
)

(instance textSound of Sound
	(properties
		priority 15
		loop -1
		number 161
	)
)

(instance terminateButton of Prop
	(properties
		view 1112
		x 253
		y 151
		signal ignAct
		loop 0
		cel 0
		priority 0
	)
)
