;;; Sierra Script 1.0 - (do not remove this comment)
(script# 135)
(include sci.sh)
(include game.sh)
(include 135.shm)
(include 135.shp)
(use Controls)
(use Cycle)
(use Door)
(use Feature)
(use Game)
(use Main)
(use System)
(use Polygon)
(use Sound)
(public
	rm135 0
)

(instance rm135 of Room
	(properties
		picture scriptNumber
		north 0
		east 0
		south 0
		west 136
		noun N_ROOM
		style dpOPEN_NO_TRANSITION
	)
	
	(method (init)
		(AddPolygonsToRoom @P_Default135)
		; To control the transition based on the source room, set the style
		; prior to calling super:init
		(switch gPreviousRoomNumber
			(110
				; Animation blackout is important, since we're coming from a room with
				; a different palette.
				(= style (| dpOPEN_CHECKBOARD dpANIMATION_BLACKOUT))
			)
			(136 (= style dpOPEN_SCROLL_LEFT) dpANIMATION_BLACKOUT)
		)
		(if (== gPreviousRoomNumber 200)
			(self setScript: EnterFromPathingScript)
		else
			(self setScript: RoomScript)
		)
		(super init:)
		(SetUpEgo)
		(switch gPreviousRoomNumber
			(136 (gEgo posn: 20 55 loop: 0))
			(200 (gEgo posn: 270 55 loop: 1))
			(else  (gEgo posn: 135 55 loop: 2))
		)
		(SetUpEgo)
		(gEgo init:)
		((Feature new:)
			noun: N_TUBE
			x: 124
			y: 126
			setOnMeCheck: omcPOLYGON (CreateNewPolygon @P_Tube)
			init:
		)
	)
)

(instance RoomScript of Script
	(properties)
	
	(method (doit)
		(super doit:)
		(if (& ctlCYAN (gEgo onControl:))
			(rm135 setScript: ExitToPathingScript)
		)
	)
	
	(method (handleEvent pEvent)
		(super handleEvent: pEvent)
	)
	
	; handle Said's, etc...
	(method (changeState newState)
		(= state newState)
		(switch state
			(0)
		)
	)
)

; Handle state changes
(instance ExitToPathingScript of Script
	(properties)
	
	(method (doit)
		(super doit:)
		(if (>= (PalVary pvGET_CURRENT_STEP) 64)
			(PalVary pvUNINIT)
			(gGame handsOn:)
			(gRoom newRoom: 200)
		)
	)
	
	(method (changeState newState)
		(= state newState)
		(switch state
			(0
				(exitEnterSound number: 135 play:)
				(gGame handsOff:)
				; Start the palette transition
				(PalVary pvINIT 888 1)
			)
		)
	)
)

(instance EnterFromPathingScript of Script
	(properties)
	
	(method (doit)
		(super doit:)
		(if (== state 1)
			(if (== 0 (PalVary pvGET_CURRENT_STEP))
				(gGame handsOn:)
				(PalVary pvUNINIT)
				(rm135 setScript: RoomScript)
			)
		)
	)
	
	(method (changeState newState)
		(= state newState)
		(switch state
			(0
				(exitEnterSound number: 136 play:)
				(gGame handsOff:)
				; 0 ticks means instantly go to palette 888, the white one.
				(PalVary pvINIT 888 0 64 1)
				; Before going in reverse, wait a few cycles for things to take effect (?)
				(= cycles 5)
			)
			(1 (PalVary pvREVERSE 1 0 1))
		; Step stop is 0. Back to the original palette.
		; We supply 1 for the direction, since it will be negated (because reverse)
		; 0 for the StepStop (the beginning)
		)
	)
)

(instance exitEnterSound of Sound
	(properties
		number 135
		priority 15
		loop 1
		flags 1
	)
)
