;;; Sierra Script 1.0 - (do not remove this comment)
(script# 140)
(include sci.sh)
(include game.sh)
(include 140.shm)
(include 140.shp)
(use Controls)
(use Cycle)
(use Door)
(use Feature)
(use Game)
(use Main)
(use System)
(use Polygon)
(use Scaler)
(use Sound)
(public
	rm140 0
)
(define NEAR_SCALE_PERCENT 100)       ; 100 is full size for the Scaler class.
(define FAR_SCALE_PERCENT 40)
(define NEAR_Y 180)
(define FAR_Y 73)
(define PAL_DARKEN_START 8)
(define PAL_DARKEN_END 64)
(define NEAR_DARKEN_Y 139)
(define FAR_DARKEN_Y 76)
(define TICK_DRIP_MAX 480)
(define TICK_DRIP_MIN 240)
(define DRIP_SOUND_FIRST 140)
(define DRIP_SOUND_LAST 142)
(local
	DripTicks =  0
)
; Set up the ego's scaling:
(procedure (UpdateEgoIntensity &tmp temp egoIntensity)
	; Let's fade the lower part of the palette as the ego moves towards the far end.
	(= temp (- (gEgo y?) FAR_DARKEN_Y))
	(= temp (Max temp 0))
	(= temp
		(/ (* 100 temp) (- NEAR_DARKEN_Y FAR_DARKEN_Y))
	)
	(= egoIntensity (Min temp 100))
	(Palette
		palSET_INTENSITY
		PAL_DARKEN_START
		PAL_DARKEN_END
		egoIntensity
	)
)

(instance rm140 of Room
	(properties
		picture scriptNumber
		north 141
		east 0
		south 137
		west 0
		noun N_ROOM
		style dpOPEN_NO_TRANSITION
	)
	
	(method (init)
		(AddPolygonsToRoom @P_Default140)
		(super init:)
		(self setScript: RoomScript)
		(SetUpEgo)
		(switch gPreviousRoomNumber
			(north (gEgo posn: 150 74 loop: 2))
			(else  (gEgo posn: 150 180 loop: 3))
		)
		(UpdateEgoIntensity)
		(gEgo
			init:
			setScale:
				Scaler
				NEAR_SCALE_PERCENT
				FAR_SCALE_PERCENT
				NEAR_Y
				FAR_Y
		)
	)
)

(instance RoomScript of Script
	(properties)
	
	(method (doit)
		(super doit:)
		(UpdateEgoIntensity)
		; If they reach the end, send them to the next room.
		(if (& ctlNAVY (gEgo onControl:))
			(gRoom newRoom: (rm140 north?))
			(gEgo setScale: 0)
		)
		; Make random drip sounds
		(-- DripTicks)
		(if (<= DripTicks 0)
			(drip
				number: (Random DRIP_SOUND_FIRST DRIP_SOUND_LAST)
				play:
			)
			(= DripTicks (Random TICK_DRIP_MIN TICK_DRIP_MAX))
		)
	)
)

(instance drip of Sound
	(properties
		priority 15
	)
)
