;;; Sierra Script 1.0 - (do not remove this comment)
(script# 141)
(include sci.sh)
(include game.sh)
(include 141.shm)
(include 141.shp)
(use Controls)
(use Cycle)
(use Door)
(use Feature)
(use Game)
(use Main)
(use System)
(use Polygon)
(use View)
(use Scaler)
(use ScaleTo)
(use Sound)
(public
	rm141 0
)
(define NEAR_SCALE_PERCENT 100)       ; 100 is full size for the Scaler class.
(define FAR_SCALE_PERCENT 80)
(define NEAR_Y 180)
(define FAR_Y 90)
(define PAL_DARKEN_START 8)
(define PAL_DARKEN_END 64)
(local
	PortalState =  $0001
)
(instance rm141 of Room
	(properties
		picture scriptNumber
		north 0
		east 0
		south 140
		west 0
		noun N_ROOM
		style dpOPEN_NO_TRANSITION
	)
	
	(method (init)
		(AddPolygonsToRoom @P_Default141)
		(Palette
			palSET_INTENSITY
			PAL_DARKEN_START
			PAL_DARKEN_END
			50
		)
		(self setRegions: DEATH_REGION)
		(super init:)
		(self setScript: RoomScript)
		(SetUpEgo)
		(switch gPreviousRoomNumber
			(else  (gEgo posn: 42 177 loop: 6))
		)
		(gEgo init:)
		(portal approachVerbs: V_DO init: setCycle: Forward)
		(portal setScale: ScaleTo 65)
		(portalSound play:)
	)
)

(instance RoomScript of Script
	(properties)
	
	(method (doit &tmp oldPortalState egoControl portalSize)
		(super doit:)
		(= oldPortalState PortalState)
		(= egoControl (gEgo onControl:))
		(if (& ctlGREEN egoControl) (|= PortalState $0001))
		(if (& ctlMAROON egoControl) (|= PortalState $0002))
		(if (& ctlPURPLE egoControl)
			(&= PortalState (~ $0001))
		)
		(if (& ctlTEAL egoControl) (&= PortalState (~ $0002)))
		(if (!= oldPortalState PortalState)
			(= portalSize
				(switch PortalState
					(0 30)
					(1 65)
					(2 65)
					(3 100)
				)
			)
			(portalSound play:)
			(portal setScale: ScaleTo portalSize)
		)
		(if (== PortalState $0003)
			; Big enough to enter
			(if (& ctlNAVY egoControl)
				; TODO: better animation
				(Palette
					palSET_INTENSITY
					PAL_DARKEN_START
					PAL_DARKEN_END
					100
				)
				(rm141 setScript: ExitViaTeleporterScript)
			)
		)
		(if (& ctlBROWN egoControl) (gRoom newRoom: 140))
	)
)

(instance ExitViaTeleporterScript of Script
	(properties)
	
	(method (changeState newState)
		(= state newState)
		(switch state
			(0
				(gGame handsOff:)
				(portalSound number: 144 play: self)
			)
			(1 (gGame handsOn:) (gRoom newRoom: 110))
		)
	)
)

(instance portal of Prop
	(properties
		scaleX 64
		scaleY 128
		view 140
		x 178
		y 90
		approachX 198
		approachY 100
		signal ignAct
		noun N_PORTAL
	)
)

(instance portalSound of Sound
	(properties
		number 143
		priority 15
	)
)
