;;; Sierra Script 1.0 - (do not remove this comment)
(script# 400)
(include sci.sh)
(include game.sh)
(include 400.shm)
(include 400.shp)
(use Cycle)
(use Door)
(use Feature)
(use Game)
(use Main)
(use System)
(use Polygon)
(use View)
(use SnowyRegion)
(public
	rm400 0
)

(instance rm400 of Room
	(properties
		picture scriptNumber
		north 0
		east 0
		south 0
		west 0
		noun N_ROOM
	)
	
	(method (init)
		(AddPolygonsToRoom @P_Fence)
		; Different containment polygons depending on where we came from:
		(if (== gPreviousRoomNumber 401)
			(AddPolygonsToRoom @P_West)
		else
			(AddPolygonsToRoom @P_East)
		)
		(self setRegions: SNOWY_REGION DEATH_REGION)
		(if (== gPreviousRoomNumber 401)
			(= style dpOPEN_SCROLL_LEFT)
		)
		(super init:)
		(self setScript: RoomScript)
		(switch gPreviousRoomNumber
			(else 
				; Set up ego view and loop (direction)
				(SetUpEgo 52 0)
				(gEgo setCel: (gEgo lastCel:))
				(gEgo posn: 260 143)
				(gEgo setScript: TransportInScript)
			)
			(401
				(gEgo posn: 32 159)
				(SetUpEgo -1 0)
				(gEgo view: (GetEgoBrightnessView))
			)
			(402
				(gEgo posn: 77 95)
				(SetUpEgo -1 4)
				(gEgo view: (GetEgoBrightnessView))
			)
			(403
				(gEgo posn: 65 175)
				(SetUpEgo -1 1)
				(gEgo view: (GetEgoBrightnessView))
			)
		)
		(gEgo setScale: NULL init:)
		(exitWest
			setOnMeCheck: omcPOLYGON (CreateNewPolygon @P_WestExit)
			init:
		)
		(exitSouth
			setOnMeCheck: omcPOLYGON (CreateNewPolygon @P_SouthExit)
			init:
		)
		(fence
			setOnMeCheck: omcPOLYGON (CreateNewPolygon @P_Fence)
			approachVerbs: V_DO V_LOOK
			init:
		)
		(rock
			setOnMeCheck: omcPOLYGON (CreateNewPolygon @P_Rock)
			approachVerbs: V_DO
			init:
		)
	)
)

(instance RoomScript of Script
	(properties)
	
	(method (doit)
		(super doit:)
		(if (& ctlNAVY (gEgo onControl:)) (gRoom newRoom: 402))
		; To the north
		(if (exitWest onMe: gEgo)
			(gRoom setScript: exitWestScript)
		)
		(if (exitSouth onMe: gEgo)
			(gRoom setScript: exitSouthScript)
		)
	)
	
	(method (changeState newState)
		(= state newState)
		(switch state
			(0)
		)
	)
)

; Handle state changes
(instance exitWest of Feature
	(properties
		x 2
		y 171
	)
)

(instance exitSouth of Feature
	(properties
		x 96
		y 186
	)
)

(instance rock of Feature
	(properties
		x 81
		y 24
		noun N_ROCK
	)
)

(instance fence of Feature
	(properties
		x 87
		y 156
		approachDist 25
		noun N_FENCE
	)
)

(instance TransportInScript of Script
	(properties)
	
	(method (changeState newState)
		(= state newState)
		(switch state
			(0
				(gEgo setCycle: BegLoop self)
			)
			(1
				(SetUpEgo 51 3)
				(gEgo init:)
				(gGame handsOn:)
			)
		)
	)
)

(instance exitWestScript of Script
	(properties)
	
	(method (changeState newState)
		(= state newState)
		(switch state
			(0
				(gGame handsOff:)
				(gEgo setMotion: MoveTo -20 160 self)
			)
			(1 (gRoom newRoom: 401) (gGame handsOn:))
		)
	)
)

(instance exitSouthScript of Script
	(properties)
	
	(method (changeState newState)
		(= state newState)
		(switch state
			(0
				(gGame handsOff:)
				(gEgo setMotion: MoveTo 123 230 self)
			)
			(1 (gGame handsOn:) (gRoom newRoom: 403))
		)
	)
)
