;;; Sierra Script 1.0 - (do not remove this comment)
(script# 401)
(include sci.sh)
(include game.sh)
(include 401.shm)
(include 401.shp)
(use Cycle)
(use Door)
(use Feature)
(use Game)
(use Main)
(use System)
(use Polygon)
(use View)
(use SnowyRegion)
(use Scaler)
(public
	rm401 0
)
(define NEAR_SCALE_PERCENT 90)
(define FAR_SCALE_PERCENT 85)
(define NEAR_Y 152)
(define FAR_Y 89)

(instance rm401 of Room
	(properties
		picture scriptNumber
		north 0
		east 0
		south 0
		west 0
		noun N_ROOM
	)
	
	(method (init)
		(AddPolygonsToRoom @P_Default401)
		(self setRegions: SNOWY_REGION DEATH_REGION)
		(if (== gPreviousRoomNumber 400)
			(= style dpOPEN_SCROLL_RIGHT)
		)
		(super init:)
		(self setScript: RoomScript)
		(switch gPreviousRoomNumber
			(else  ; 402
				; Set up ego view and loop (direction)
				(SetUpEgo -1 1)
				(gEgo posn: 179 97)
				(gEgo view: (GetEgoBrightnessView))
			)
			(400
				(SetUpEgo -1 1)
				(gEgo posn: 275 155)
				(gEgo view: (GetEgoBrightnessView))
			)
		)
		(gEgo
			init:
			setScale:
				Scaler
				NEAR_SCALE_PERCENT
				FAR_SCALE_PERCENT
				NEAR_Y
				FAR_Y
		)
		(exitNorth
			setOnMeCheck: omcPOLYGON (CreateNewPolygon @P_NorthExit)
			init:
		)
		(exitEast
			setOnMeCheck: omcPOLYGON (CreateNewPolygon @P_EastExit)
			init:
		)
		(cliffs
			setOnMeCheck: omcPOLYGON (CreateNewPolygon @P_Cliff)
			init:
		)
		(rock
			setOnMeCheck: omcPOLYGON (CreateNewPolygon @P_Rock)
			init:
		)
	)
)

(instance RoomScript of Script
	(properties)
	
	(method (doit)
		(super doit:)
		(if (exitNorth onMe: gEgo) (gRoom newRoom: 402))
		(if (exitEast onMe: gEgo)
			(gRoom setScript: exitEastScript)
		)
	)
	
	(method (changeState newState)
		(= state newState)
		(switch state
			(0)
		)
	)
)

; Handle state changes
(instance exitNorth of Feature
	(properties
		x 200
		y 88
	)
)

(instance exitEast of Feature
	(properties
		x 312
		y 155
	)
)

(instance exitEastScript of Script
	(properties)
	
	(method (changeState newState)
		(= state newState)
		(switch state
			(0
				(gGame handsOff:)
				(gEgo setMotion: MoveTo 340 158 self)
			)
			(1 (gRoom newRoom: 400) (gGame handsOn:))
		)
	)
)

(instance cliffs of Feature
	(properties
		x 150
		y 100
		noun N_CLIFF
	)
)

(instance rock of Feature
	(properties
		x 24
		y 125
		noun N_ROCK
	)
)
