;;; Sierra Script 1.0 - (do not remove this comment)
(script# 402)
(include sci.sh)
(include game.sh)
(include 402.shm)
(include 402.shp)
(use Cycle)
(use Door)
(use Feature)
(use Game)
(use Main)
(use System)
(use Polygon)
(use SnowyRegion)
(use View)
(use Scaler)
(public
	rm402 0
)
(define NEAR_SCALE_PERCENT 80)
(define FAR_SCALE_PERCENT 70)
(define NEAR_Y 142)
(define FAR_Y 81)

(instance rm402 of Room
	(properties
		picture scriptNumber
		north 0
		east 0
		south 0
		west 0
		noun N_ROOM
	)
	
	(method (init)
		(AddPolygonsToRoom @P_Default402)
		(self setRegions: SNOWY_REGION FLOPPYDISK_REGION)
		(super init:)
		(self setScript: RoomScript)
		(switch gPreviousRoomNumber
			(else  ; 400
				; Set up ego view and loop (direction)
				(SetUpEgo -1 4)
				(gEgo posn: 138 99)
				(gEgo view: (GetEgoBrightnessView))
			)
			(401
				; Set up ego view and loop (direction)
				(SetUpEgo -1 1)
				(gEgo posn: 247 98)
				(gEgo view: (GetEgoBrightnessView))
			)
		)
		(gEgo
			init:
			setScale:
				Scaler
				NEAR_SCALE_PERCENT
				FAR_SCALE_PERCENT
				NEAR_Y
				FAR_Y
		)
		(exitNorth
			setOnMeCheck: omcPOLYGON (CreateNewPolygon @P_NorthExit)
			init:
		)
		(exitEast
			setOnMeCheck: omcPOLYGON (CreateNewPolygon @P_EastExit)
			init:
		)
		(table
			approachVerbs: V_DO V_LOOK
			setOnMeCheck: omcPOLYGON (CreateNewPolygon @P_Table)
			init:
		)
		(cliffs
			setOnMeCheck: omcPOLYGON (CreateNewPolygon @P_Cliff)
			init:
		)
		(rock
			setOnMeCheck: omcPOLYGON (CreateNewPolygon @P_Rock)
			init:
		)
	)
)

(instance RoomScript of Script
	(properties)
	
	(method (doit)
		(super doit:)
		(if (exitNorth onMe: gEgo) (gRoom newRoom: 400))
		(if (exitEast onMe: gEgo) (gRoom newRoom: 401))
	)
	
	(method (changeState newState)
		(= state newState)
		(switch state
			(0)
		)
	)
)

; Handle state changes
(instance exitNorth of Feature
	(properties
		x 155
		y 86
	)
)

(instance exitEast of Feature
	(properties
		x 264
		y 81
	)
)

(instance table of Feature
	(properties
		x 126
		y 127
		noun N_TABLE
		approachX 176
		approachY 115
	)
)

(instance cliffs of Feature
	(properties
		x 150
		y 185
		noun N_CLIFF
	)
)

(instance rock of Feature
	(properties
		x 160
		y 20
		noun N_ROCK
	)
)
