;;; Sierra Script 1.0 - (do not remove this comment)
(script# 403)
(include sci.sh)
(include game.sh)
(include 403.shm)
(include 403.shp)
(use Cycle)
(use Door)
(use Feature)
(use Game)
(use Main)
(use System)
(use Polygon)
(use View)
(use Sound)
(public
	rm403 0
)

(instance rm403 of Room
	(properties
		picture scriptNumber
		north 0
		east 0
		south 0
		west 0
		noun N_ROOM
	)
	
	(method (init)
		(AddPolygonsToRoom @P_Default403)
		(super init:)
		(self setScript: RoomScript)
		(switch gPreviousRoomNumber
			(else  (SetUpEgo -1 2) (gEgo posn: 84 25))         ; 400
			; Set up ego view and loop (direction)
			(404 (SetUpEgo -1 1) (gEgo posn: 226 170))
		)
		(gEgo init:)
		(cliff
			setOnMeCheck: omcPOLYGON (CreateNewPolygon @P_Cliff)
			init:
		)
		(tree
			setOnMeCheck: omcPOLYGON (CreateNewPolygon @P_Tree)
			init:
		)
		(pond
			setOnMeCheck: omcPOLYGON (CreateNewPolygon @P_Pond)
			init:
		)
		(wind play:)
	)
)

(instance RoomScript of Script
	(properties)
	
	(method (doit)
		(super doit:)
		(if (& ctlNAVY (gEgo onControl:))
			(gRoom setScript: ExitNorthScript)
		)
		(if (& ctlGREEN (gEgo onControl:))
			(gRoom setScript: ExitSouthScript)
		)
	)
	
	(method (changeState newState)
		(= state newState)
		(switch state
			(0)
		)
	)
)

; Handle state changes
(instance ExitNorthScript of Script
	(properties)
	
	(method (changeState newState)
		(= state newState)
		(switch state
			(0
				(gGame handsOff:)
				(gEgo setMotion: MoveTo 47 -4 self)
			)
			(1 (gGame handsOn:) (gRoom newRoom: 400))
		)
	)
)

(instance ExitSouthScript of Script
	(properties)
	
	(method (changeState newState)
		(= state newState)
		(switch state
			(0
				(gGame handsOff:)
				(gEgo setMotion: MoveTo 270 230 self)
			)
			(1 (gGame handsOn:) (gRoom newRoom: 404))
		)
	)
)

(instance tree of Feature
	(properties
		x 145
		y 49
		noun N_TREE
	)
)

(instance pond of Feature
	(properties
		x 193
		y 120
		noun N_POND
	)
)

(instance cliff of Feature
	(properties
		x 33
		y 144
		noun N_CLIFF
	)
)

(instance wind of Sound
	(properties
		priority 15
		number 403
		loop -1
		flags 1
	)
)
