;;; Sierra Script 1.0 - (do not remove this comment)
(script# 404)
(include sci.sh)
(include game.sh)
(include 404.shm)
(include 404.shp)
(use Cycle)
(use Door)
(use Feature)
(use Game)
(use Main)
(use System)
(use Polygon)
(use View)
(use Reverse)
(use Sound)
(public
	rm404 0
)
(define PALETTE_GREY_Y 30)
(define PALETTE_COLOR_Y 123)
(local
	GoingInward =  FALSE
)
(instance rm404 of Room
	(properties
		picture scriptNumber
		north 0
		east 0
		south 0
		west 0
		noun N_ROOM
	)
	
	(method (init)
		(self setRegions: FLOPPYDISK_REGION)
		(AddPolygonsToRoom @P_Default404)
		(super init:)
		(self setScript: RoomScript)
		(switch gPreviousRoomNumber
			(else  (SetUpEgo -1 2) (gEgo posn: 112 36)) ; 403
		; Set up ego view and loop (direction)
		)
		(gEgo init:)
		(glowyThing setCycle: Forward init:)
	)
	
	(method (dispose)
		(PalVary pvUNINIT)
		(super dispose: &rest)
	)
)

(instance RoomScript of Script
	(properties)
	
	(method (doit &tmp egoY amount shouldGoInward)
		(super doit:)
		(if (& ctlNAVY (gEgo onControl:))
			(gRoom setScript: ExitNorthScript)
		)
		; When the ego gets close, the glowy thing goes inward.
		(if (& ctlGREEN (gEgo onControl:))
			(= shouldGoInward TRUE)
		else
			(= shouldGoInward FALSE)
		)
		(if (!= GoingInward shouldGoInward)
			(= GoingInward shouldGoInward)
			(if GoingInward
				(glowyThing setCycle: Reverse)
				(glowyThing setScript: ExitScript)
			else
				(glowyThing setCycle: Forward)
				(glowyThing setScript: NULL)
			)
		)
		(= egoY (gEgo y?))
		(= egoY (Min egoY PALETTE_COLOR_Y))
		(= egoY (Max egoY PALETTE_GREY_Y))
		(= amount
			(/
				(* 64 (- egoY PALETTE_GREY_Y))
				(- PALETTE_COLOR_Y PALETTE_GREY_Y)
			)
		)
		(PalVary pvUNINIT)
		; In order to adjust to a position between two palettes at each game step,
		; we "set from resource" after calling pvINIT. Otherwise, pvINIT begins from the current
		; active screen palette
		(PalVary pvINIT 404 0 amount 0)                        ; 404 is the color palette
		(Palette palSET_FROM_RESOURCE 405)
	)
	            ; 405 is the grey palette
	(method (changeState newState)
		(= state newState)
		(switch state
			(0)
		)
	)
)

; Handle state changes
(instance ExitScript of Script
	(properties)
	
	(method (init)
		(super init: &rest)
		(exitSound play: setVol: 10)
	)
	
	(method (changeState newState)
		(= state newState)
		(switch state
			; Make the blobby thing go faster and faster until we exit.
			(0 (= seconds 1))
			(1
				(if (== (client cycleSpeed?) 1)
					; Muting or stoping a MIDI sound is risky. It could end before a note-off,
					; and the note could keep going.
					; (exitSound stop:)
					; (exitSound mute:)
					; So I'll set the volume to zero instead. I guess it may keep playing,
					; hopefully that doesn't become an issue.
					(exitSound setVol: 0)
					(gRoom newRoom: 110)
				else
					(exitSound setVol: (+ (exitSound vol?) 15))
					(client cycleSpeed: (- (client cycleSpeed?) 1))
					(self changeState: 0)
				)
			)
		)
	)
	
	(method (dispose)
		(client cycleSpeed: 6)
		(super dispose: &rest)
	)
)

(instance ExitNorthScript of Script
	(properties)
	
	(method (changeState newState)
		(= state newState)
		(switch state
			(0
				(gGame handsOff:)
				(gEgo setMotion: MoveTo 42 -4 self)
			)
			(1 (gGame handsOn:) (gRoom newRoom: 403))
		)
	)
)

(instance glowyThing of Prop
	(properties
		view 404
		x 170
		y 170
		z 15
		cycleSpeed 6
		signal ignAct
		noun N_BLOB
	)
)

(instance exitSound of Sound
	(properties
		loop -1
		priority 15
		number 512
		flags 1
	)
)
