;;; Sierra Script 1.0 - (do not remove this comment)
(script# 600)
(include sci.sh)
(include game.sh)
(include 600.shm)
(include 600.shp)
(use Cycle)
(use Door)
(use Feature)
(use Game)
(use Main)
(use System)
(use Polygon)
(use View)
(use Orbit)
(use Chase)
(use Approach)
(public
	rm600 0
)

(instance rm600 of Room
	(properties
		picture scriptNumber
		north 0
		east 0
		south 0
		west 0
		noun N_ROOM
	)
	
	(method (init)
		(self setRegions: FLOPPYDISK_REGION)
		(AddPolygonsToRoom @P_Default600)
		(super init:)
		(self setScript: RoomScript)
		(switch gPreviousRoomNumber
			(else  (SetUpEgo -1 0) (gEgo posn: 30 100))
		; Set up ego view and loop (direction)
		)
		(tree
			setOnMeCheck: omcCOLORS ctlYELLOW
			approachVerbs: V_DO
			init:
		)
		(sphere
			setOnMeCheck: omcCOLORS ctlFUCHSIA
			approachVerbs: V_DO
			init:
		)
		(water setOnMeCheck: omcCOLORS ctlRED init:)
		(gEgo init:)
	)
	
	(method (doit)
		(super doit:)
		(Palette palANIMATE 240 255 4)
	)
)

(instance RoomScript of Script
	(properties)
	
	(method (doit)
		(super doit:)
		; code executed each game cycle
		(if (& (gEgo onControl:) ctlCYAN)
			(gRoom setScript: ExitScript)
		)
	)
	
	(method (changeState newState)
		(= state newState)
		(switch state
			(0)
		)
	)
)

; Handle state changes
(instance ExitScript of Script
	(properties)
	
	(method (changeState newState)
		(= state newState)
		(switch state
			(0
				(gGame handsOff:)
				(gEgo setMotion: MoveTo -25 (gEgo y?) self)
			)
			(1 (gGame handsOn:) (gRoom newRoom: 210))
		)
	)
)

(instance tree of Feature
	(properties
		x 176
		y 133
		approachX 153
		approachY 133
		onMeCheck omcCOLORS
		noun N_TREE
	)
)

(instance sphere of Feature
	(properties
		x 161
		y 63
		approachX 135
		approachY 88
		onMeCheck omcCOLORS
		noun N_SPHERE
	)
)

(instance water of Feature
	(properties
		x 296
		y 170
		onMeCheck omcCOLORS
		noun N_WATER
	)
)
