;;; Sierra Script 1.0 - (do not remove this comment)

(script# SNOWY_REGION)
(include sci.sh)
(include game.sh)
(use Game)
(use View)
(use System)
(use Main)
(use Sound)
(use Controls)
(public

	snowyRegion 0
	GetEgoBrightnessView 1
)
(local
	babyIsCrying =  0
)
(procedure (GetEgoBrightnessView)
	(if (& ctlYELLOW (gEgo onControl: TRUE))
		(return 50)
	else
		(return 51)
	)
)

(instance snowyRegion of Region
	(properties
		keep FALSE
	)
	
	(method (init)
		(super init: &rest)
		(windSound play:)
		(self setScript: changeEgoBrightness)
	)
)

(instance changeEgoBrightness of Script
	(properties)
	
	(method (doit &tmp egoView)
		(super doit:)
		(= egoView (gEgo view?))
		(if (or (== 50 egoView) (== 51 egoView))
			(gEgo view: (GetEgoBrightnessView))
		)
	)
)

(instance windSound of Sound
	(properties
		priority 15
		number 400
		loop -1
	)
	
	(method (play)
		(= babyIsCrying 1)
		(super play:)
	)
	
	(method (stop)
		(= babyIsCrying 0)
		(super stop:)
	)
	
	(method (check)
		; Clearly, in ScummVM, DoAudio(audPAUSE) does something, whereas in Sierra, it doesn't. Maybe it's asking if audio is paused?
		; (if (((babyIsCrying and DoAudio(audPAUSE)) and (== DoAudio(audPOSITION) -1)) and TRUE)
		(if (and babyIsCrying (== (DoAudio audPOSITION) -1))
			(self play:)
		)
		(super check:)
	)
)
